


;05/12/12 Reversed the sequence the data from the scales is shifted into the 48 bit value held in registers R3 to R8 (In Pin_change_Int service routine)
;         Added BIN to BCD routine to display the output in decimal.
;		  Added subroutine Invert2x24 to change the data from 2 * 24 scales to the correct sense
;		  Added subroutine RepositionBCD to move the 28 bits received from BCD scales down to lower order positins in 48 bit buffer

;06/12/13 Yadroid001.asm renamed as Yadroid4001.asm for the code to be modified to run on a Attiny 4313 instead of an Attiny2313
;         I think R29 (Top byte of 16 bit Y register) and R31 (Top byte of 16 bit Z register) will now need to be set to address the larger SRAM space
;		  They will also have to be saved in subroutines that use them. 
;           Still works after these changes.

;07/12/13 Changing code so that unused least significant nibble of BCD output is not sent to UART
;         Remove the DR# scale type and the CR/LF from the output string.
;		  Add code to put x, y, z or w at the stort of the output string and ; at the end.
;		  Add leading sero blanking to the BCD scale output code.

;08/12/13 Had problem with locking up when enteing active mode. Found this was caused by a label name error.
;		  Added code to test 2 * 24 bit data for negative value (Bit 7 of 24 bit frame set) If so do a 2's complemant and set negative flag
;		  Also added code to insert  minus sign if negative flag set
;                 Now renamed V4003 
;			Jxxx type labels changed to more meaningfull labels.

;10/12/13
;			Started with a copy of V4003
;			Changed the version text to V4004
; Changing the code for formatting scale data from in line code to subroutines.

;11/12/13
;			Format scale display now working in subroutines.
;			About 12:20 Started to reverse sequence of scale data storage buffer R3 to R8

;11/12/13 20:52  Yadroid4004 copied to "Yadroid4005" directory and renamed Yadroid4005
; Being modified to work with BCD7 (HF) scales 


;15/12/13 20:37  Now working with 2 * 24, 7BCD & BIN6 scales  

;15/12/13 20:51  Version 4005 now renamed to version4006 and started as project Yadroid4006

;16/12/13 10:44 Fixed bug in the code that was causing error an after reading scale 2 in active mode which was caused
; by the way I tested for the invalid scale code of 0xFF being read from EEPROM I just tested for negative which meant that
; 0x99 was also seen as invalid.
; Adding code to set 2 * 24 bit scales to fast mode

;17/12/13 09:30 Started to add code to allow it to start in setup mode at power on if a jumper is fitted. This uses PD5
;which is normaly an output. It will initialy be set to an input to see if the jumper is inserted.
;
;17/12/13 15:33  Set fast mode now working. Jumper for starting in setup mode working
;
;17/12/13 16:35  Starting to remove unwanted code.
;
;18/12/13 10:40  V4006 renamed to V4007  Starting to add code for setup mode
;  Also starting to replace fixed SRAM addresses with location names

;21/12/13 11:50  Setup menu code now working
;				Changing startup to be in active mode.
;21/12/13 15:00  Code added to set scales into fast mode. 5 second delay added before setting fast mode.

;21/12/13 15:11   Name changed from Yadroid4007 to 3_Mode_interface_V01

;23/12/13		Name changed to 3_Mode_interface_V02  Code added to select between absolute and relative data for 2 * 24 scales
;				timeout delays reduced to 500 mS

;24/12/13		Name changed to 3_Mode_interface_V03  Removing the use of "scale config byte"

;26/12/13 08:20  Still a few more changes to make. Seems to be working in present state.
;
;26/12/13 12:09   All  scale config byte code removed 

;26/12/13 12:18   Renamed to 3_Mode_interface_V04  Adding code to test for fast mode.

;26/12/13 22:52		Subroutine added to test for fast mode but not yet tested.

;26/12/13 12:44		Fast mode test now working.

;26/12/13_15:21    3_Mode_interface_V04 copied here and renamed as 4_Mode_interface_V01. This is the starting point of a version to
					;also support iGaging scales.

;29/12/13 18:09    4_Mode_interface  iGaging clock generation using timer 0 now working. Writing iGaging read code.
;31/12/13 10:52					iGaging read code now seems to be working

;31/12/13 10:52    4_Mode_interface_V01 renamed as V02 Starting to modify BIN6 code to work without use of timer 0 (Which is now used for iGaging code.)

;31/12/13 17:03     Code for BIN6 scales now wworking without the use of timers.

;01/01/14 08:57     4_Mode_interface_V02 Renamed to 4_Mode_interface_V03 Removing some unused code. Change iGaging output formating routine from 
;                   raw data (Which was used for testing.) to iGaging format routine.

;01/01/14 12:55      4_Mode_interface_V03 Changes made. Seems to work as expected.


;26/03/14 20:45	    Name changed to 5_Mode_interface_V00   Start of adding code to support angle gauge.

;07/04/14 18:47      Name changed to 5_Mode_interface_V01 now working

;11/04/14 09:34    Added instruction to Init_io routine to disable pull up resistors. This is to prevent possible damage to a scale if connected 
;					directly to I/O pin rather than via a comparator.	     

;11/04/14 16:20     Renamed to 5_Mode_interface_V02

;12/04/14 10:11   Re enabled pull up resistors as interface did not work very well without comparators.

;18/05.14  19:16 re named to 6_Mode_Interface_V00.asm.    Starting to add code to interface with tacho module via serial input.

;07/07/14 18:14 re named to 6_Mode_Interface_V01.asm. Start of correcting a few errors

;	CPU Attiny4313
;	20 Mhz crystal used.

; I/O pin useage

; Scale 1 input
;	Clock	Pin 12 PB0
;	Data	Pin 16 PB4
;	
; Scale 2 input
;	Clock	Pin 13 PB1
;	Data	Pin 17 PB5
;	
; Scale 3 input
;	Clock	Pin 14 PB2
;	Data	Pin 18 PB6
;	
; Scale 4 input
;	Clock	Pin 15 PB3
;	Data	Pin 19 PB7
;	

;CD4051N Multiplexer select signals
;	INH	Pin 11 PD6
;	A	Pin 9  PD5
;	B	Pin 8  PD4
;	C	Pin 7  PD3


;Serial data  (With respect to ATtiny2313
;	In 	Pin 2  PD0	(RXD)
;	Out	Pin 3  PD1	(TXD)

;										----------------------------
;Register use 
; R8,R7,R6 and R5,R4,R3 form two 24 bit registers to shift data in from scales

;	----------------------------------------------------------------------------------------------------------------
;
.macro	String_Out	; @0:ADDRESS from program-memory
	LDI	Zl,low(@0*2)
	LDI	Zh,high(@0*2)
	 RCALL   T_String	
.endmacro
;									-----------------


; -----------------------------------------------------------------------------------------------------------------------------------------
; Baud rate constant. Comment out as required
;For 19200 baud  baud rate = 20 * 10^6/(16(64 +1)) = 20 * 10^6/1040 = 19230.8 bauds

.EQU	BAUD_L = 0x40

;									------------------
;For 138400 baud  baud rate = 20 * 10^6/(16(32 +1)) = 20 * 10^6/528 =  bauds 37878.79 bauds    (98.64%)
;.EQU	BAUD_L = 0x20

;									------------------
;For 138400 baud  baud rate = 20 * 10^6/(16(31 +1)) = 20 * 10^6/512 =  bauds 39062.5 bauds   (101.73%)

;.EQU	BAUD_L = 0x1F 
;									------------------
; for 115200 bauds baud rate = 20 * 10^6/(16(10 +1)) = 20 * 10^6/176 =  bauds 11363.6 bauds   (98.64%)

;.EQU	BAUD_L = 0x0A
;
; -----------------------------------------------------------------------------------------------------------------------------------------

.DEF	Bits_in_frame = R2

;.DEF	LZBF = R26				;Leading zero blanking flag Cannot use a new definition for R26 as it has already been defined as Xl
;									--------------------
 .DSEG

  .ORG	0x60 


Temp01:			.BYTE 1		;Used to save registers for a few instructions.

Scale_0_Type:	.BYTE 1		;   Scale type as in setup routine  0 to 5 
Scale_1_Type:	.BYTE 1		;
Scale_2_Type:	.BYTE 1		;
Scale_3_Type:	.BYTE 1		;
;Scale_4_Type:	.BYTE 1		;

;Current scale information
Scale_Number:		.BYTE 1		;Current scale number
Scale_Type:			.BYTE 1		;Current scale type. (As entered in setup menu.) Bit 7 will be used as fast mode enable flag
								;Bit 6 will select relative data if set absolute data is clear (Bit 6 & 7 only used with 2 * 24 scales
Scale_bit_mask:		.BYTE 1		;Bits 0 - 3 contain mask bits to select scale clock bit Bits 4 - 7 contain mask bits to select scale data bit
Scale_bit_count:	.BYTE 1		;number of bits in a frame + 1 for current scale type

 .ORG	0x90 

RBCD0:			.BYTE 1		;MSBThese following variable must be in this sequence ( 7 bytes )
RBCD1:			.BYTE 1
RBCD2:			.BYTE 1
RBCD3:			.BYTE 1		;LSB

Rbin0:			.BYTE 1		;MSB
Rbin1:			.BYTE 1
Rbin2:			.BYTE 1		;LSB

Flags:			.BYTE 1			; Various flag bits
							; Bit 7 Negative flag for data from 2 * 24 scales and iGaging scales
							; Bit 6 Leading zero blanking flag  (LZBF)

; Variables used for iGaging read

IG_State:			.BYTE 1	; 0 for 22 uS high, 1 for 88 uS low 3 for 	4760 us Low	
IG_Bit_Count:		.BYTE 1	; Will be twice the bit number  bit 0 will decide if the signal is high or low. Will count up from zero Bit 0 = 0 will be clock high
IG_Flags:			.BYTE 1	; Set by program to request read, Cleared by interrupt routine when 21 bits read and data is available.

; Variables used for Angle Gauge display
Tenths:				;stores tenths and units of degrees in BCD format

; Variables used for tacho

Tacho_L:		.BYTE 1	; Low byte of 24 bit tacho value	(Bits 0 to 7)
Tacho_M:		.BYTE 1	; Middle byte of 24 bit tacho value	(Bits 8 to 15
Tacho_H:		.BYTE 1	; High byte of 24 bit tacho value	(Bits 16 to 23)
Spare_Space:		.BYTE 8	;  Unused - In case received data overuns past Tacho_H
Byte_Count:		.BYTE 1	; Byte pointer Useed to point to correct byte in 24 bit tach value.
Tacho_Flags:		.BYTE 1	; Bit 0 set for new value to be displayed.
Word_Timer:		.BYTE 1	; Used to check that 3 bytes come within allocated time   (With Baude rate of 19200 will alow 3 mS)
Timer_L:		.BYTE 1	; Low byte of 16 bit timer used to handle serial data from tacho unit (Incremented every 102.4 uS in timer 0 interrupt routine.
Timer_H:		.BYTE 1	; High byte of above 16 bit timer

;													-----------------------------
.CSEG
.ORG	0x0000
		RJMP    Start       		; Jump To Location 0x0013 Start of program

.ORG	0x0005					;Timer/Counter1 Overflow  (Interrupt not used.)
		RETI

.ORG	0x0006	
		RJMP	TIM0_OVF_Int

.ORG	0x0007			;USART0_RXC
        RJMP    USART_RX_Int       ; 		(USART0 RX complete interrupt)


.ORG	0x000B
;Interrupt on pin change vector
        RJMP    Pin_change_Int       ; Interrupt vector Pin change interrupt

		
.ORG	0x000D
		RJMP	TIMER0_COMPA_Int	



;Main program start
;Initialize hardware
;Reset_Interface
;Set  pointer

.ORG	0x0013
Start:
        LDI     R16,LOW (RAMEND)				;Load immediate  Top address of SRAM memory
        OUT     SPL,R16							;(SPL) (Stack pointer) (Was 0xDF for Attiny2313)


        RCALL   USART_Init				
        RCALL   Init_IO				
        RCALL   Set_Timer_Prescaler				;Set_Timer_prescaler to 256

		;Test if startup mode jumper is inserted

		SBIC	PIND,5				;skip if Setup mode jumper  inserted:	
		RJMP	Normal_Mode

;								************************

Setup_Mode:

		RCALL	Load_Scale_Types	;Load scale types from EEPROM



		String_Out	Version			;Macro

		String_Out	Setup_Msg		;Macro

;

Setup_01:
		IN		R16,UDR				;Just to clear RXC bit

		String_Out	Scale_to_conf	;Macro

	


		;Get response
		RCALL	Uart_RX
		RCALL	USART_TX			;Echo character
		CPI		R16,'X'
		BRNE	Setup_02
		String_Out	Return_Normal	;macro
		RJMP	Normal_Mode			;Exit setup mode to Normal mode

Setup_02:							;Test if number input is 0 - 3
		SUBI	R16,'0'				;Subtract ASCII "0" to convert to number
        CPI     R16,0x05
        BRCC    Not_Scale_0_3			;Branch if carry cleared  (Value is NOT 0 to 3)
        RJMP    Number_ok	
			
Not_Scale_0_3:
		String_Out	Message_Invalid_number	;Message_Bad_Range	;macro
		RJMP	Setup_01					;Ask again


Number_ok:      
		STS		Scale_Number,R16		;Save scale number
	
		String_Out	Scale_types					;Macro	
		String_Out	Space_0						;Macro	
		String_Out	Not_configured				;Macro		
		String_Out	Space_1						;Macro		
		String_Out	Twox24						;Macro	
		String_out	Space_2						;Macro	
		String_out	Seven_BCD					;Macro	
		String_out	Space_3						;Macro	
		String_out	Bin_6						;Macro	
		String_out	Space_4						;Macro	
		String_out	IG_21_Bit					;Macro	
		String_out	Space_5						;Macro	
		String_out	Angle_Gauge					;Macro	
		String_out	Scale_type_Q				;Macro

		LDS		R16,Scale_Number
		; Output current scale type number and description
		RCALL	Get_Scale_Type     ;On entry scale number in R16 
	
		STS		Scale_Type,R16		;Save scale type (Full byte)   (It should be there from Get_Scale_Type subroutine )
		ANDI	R16,0x0F
		MOV		R18,R16				;Save scale type (Without fast mode flag)
		
		; Display current type
		CPI		R18,1				;Is it 2 * 24 ?
		BRNE	Test_7BCD
		LDI		R16,'1'
		RCALL	USART_TX
		LDI		R16,')'
		RCALL	USART_TX
	
		String_Out	Twox24			;macro
		RJMP	Change_Type

Test_7BCD:
		CPI		R18,2				;Is it 7BCD ?
		BRNE	Test_BIN6
		LDI		R16,'2'
		RCALL	USART_TX
		LDI		R16,')'
		RCALL	USART_TX
		String_Out	Seven_BCD
		RJMP	Change_Type

Test_BIN6:
		CPI		R18,3				;Is it BIN6 ?
		BRNE	Test_21bit
		LDI		R16,'3'
		RCALL	USART_TX
		LDI		R16,')'
		RCALL	USART_TX
		String_Out	Bin_6			;macro
		RJMP	Change_Type

Test_21bit:
		CPI		R18,4				;Is it 21 Bit ?
		BRNE	Test_Angle_G
		LDI		R16,'4'
		RCALL	USART_TX
		LDI		R16,')'
		RCALL	USART_TX
		String_Out	IG_21_Bit			;macro
		RJMP	Change_Type

Test_Angle_G:
		CPI		R18,5				;Is it Angle gauge ?
		BRNE	NO_Scale
		LDI		R16,'5'
		RCALL	USART_TX
		LDI		R16,')'
		RCALL	USART_TX
		String_Out	Angle_Gauge			;macro
		RJMP	Change_Type

No_Scale:			;Must be 0 or any other value
		LDI		R16,'0'
		RCALL	USART_TX
		LDI		R16,')'
		RCALL	USART_TX
		String_Out	Not_configured		;macro
									; Existing type is still in R18

							; Ask for new type or CR to accept current type
Change_Type:	
		String_Out New_type			;macro
		;Get response 0 - 5 or CR
	
		RCALL	Uart_RX				;Character returned in R16
		RCALL	USART_TX			;Echo character
		CPI		R16,0x0D			; Is it CR
		BREQ	No_Change_T
		CPI		R16,0x0A			; Is it LF
		BREQ	No_Change_T
	
		SUBI	R16,'0'				;Subtract ASCII "0" to convert to number
		ANDI	R16,0x0F			;Mask off top nibble. Bit 7 is used for set fast mode flag
		MOV		R18,R16				;Save type
        	CPI     R16,0x06
        	BRCS    Type_ok   			;Branch if carry set  (Value is 0 to 5)
 
		String_Out	Not_valid_type		;macro
		RJMP	Change_Type			;Ask again

Type_OK:
		LDS		R16,Scale_Number
		MOV		R17,R18						;Only contains low nibble at this point
		STS		Scale_type,R17
		RCALL	Save_Scale_Type		;Scale number in R16, Scale type in R17  Save in reqired Scale_x_Type: location
No_Change_T:			;(R17 will contain scale type)

;If type = 1 (2 * 24) then  ask about fast mode and data required
Fast_Q:
		CPI		R18,1				; 1 is for 2 * 24 bit scale so ask if fast mode to be enabled (At this point R18 just contains low nibble)
		BREQ	FQ_01
		RJMP	Not_Type_1

FQ_01:
		String_Out	Enable_fast_a

		;Now output current state of fast mode flag
		LDS		R16,Scale_Number
		RCALL	Get_Scale_Type   ;Type returned in R16 Bit 7 will be set if fast mode is enabled
		MOV		R17,R16
	;	LDS		R16,Scale_Type
		TST		R16
		LDI		R16,'Y'

		BRMI	Yes_
		LDI		R16,'N'
Yes_:	
		RCALL	USART_TX
		String_Out	Enable_fast_b		;macro

										;Wait for response  Y, N od CR
		RCALL	Uart_RX
		RCALL	USART_TX			;Echo character
		CPI		R16,0x0D			; Is it CR
		BREQ	No_Change_F
		CPI		R16,0x0A			; Is it LF
		BREQ	No_Change_F
		ANDI	R16,0x5F			;If upper lower case convert to upper
		CPI		R16,'Y'
		BREQ	ENA_F
		CPI		R16,'N'
		BREQ	DIS_F
		RJMP	Fast_Q

ENA_F:
		SBR		R17,0x80
		RJMP	Save_F_mode_flag
DIS_F:
		CBR		R17,0x80
Save_F_mode_flag:
		LDS		R16,Scale_Number
		STS		Scale_type,R17
		RCALL	Save_Scale_Type		;Scale number in R16, Scale type in R17  Save in reqired Scale_x_Type: location
					;(R17 will contain scale type)
	;	STS		Scale_Type,R17   ;Probably not required here
No_Change_F:

Data_Q:
		String_Out	Data_Type_a		;.macro
		;get current setting  Should still be in R17
		LDI		R16,'r'
		SBRS	R17,6				; skip if bit 6 is set  (Set for relative data)
		LDI		R16,'a'
		RCALL	USART_TX	;Output "a" or "r"

		String_Out	Data_Type_b		;.macro
										;Wait for response   "a", "r", or CR
		RCALL	Uart_RX
		RCALL	USART_TX			;Echo character
		CPI		R16,0x0D			; Is it CR
		BREQ	No_Change_D
		CPI		R16,0x0A			; Is it LF
		BREQ	No_Change_D
		ANDI	R16,0x5F			;If upper lower case convert to upper
		CPI		R16,'R'
		BREQ	ENA_D
		CPI		R16,'A'
		BREQ	DIS_D
		RJMP	Data_Q				;If invalid response

ENA_D:
		SBR		R17,0x40							;Set bit 6 to select relative data 
		RJMP	Save_D_mode_flag
DIS_D:
		CBR		R17,0x40
Save_D_mode_flag:
		STS		Scale_Type,R17 
		RCALL	Save_Scale_Type		;Scale number in Scale_number, Scale type in Scale_type  Save in reqired Scale_x_Type: location
					;(R17 will contain scale type)
No_Change_D:




Not_Type_1:

		CPI		R18,5				; Angle gauge  If  so st bit 6 to select data in R8 - R6 (At this point R18 just contains low nibble)
		BRNE	Not_Type_5	
		SBR		R17,0x40							;Set bit 6 to select  data from R8 - R6
		STS		Scale_Type,R17 
		RCALL	Save_Scale_Type		;Scale number in Scale_number, Scale type in Scale_type  Save in reqired Scale_x_Type: location

Not_Type_5:
		String_Out	Save_changes		;macro
		;If Y save changes
		;Go back to scale to configure
		RCALL	Uart_RX
		RCALL	USART_TX			;Echo character
		ANDI	R16,0x5F			;If upper lower case convert to upper
		CPI		R16,'Y'
		BREQ	Save_to_EEPROM
		CPI		R16,'N'
		BRNE	Not_Type_1
		RJMP	Setup_01

Save_to_EEPROM:
		LDS		R16,Scale_Number	;R17 should still contain scale type
		SBIC    EECR,1				;Skip if bit in I/O register cleared  (EECR) Eprom control register
        	RJMP    Save_to_EEPROM
        	OUT     EEAR,R16	   
       		OUT     EEDR,R17			
        	CLI							;Global Interrupt Disable
        	SBI     EECR,2				;Set bit in I/O register  (EECR) Eprom control register
        	SBI     EECR,1				;Set bit in I/O register  (EECR) Eprom control register

		RJMP	Setup_01


;		*********************************************************************************************************

; ***************************************************************************************************************
; *		Load scale type (As used in setup mode (0 - 5)							*
; *		On entry scale number is in R16									*
; *		On return scale type is in R16 & Scale_Type							*
; *														*
; ***************************************************************************************************************

Get_Scale_Type:
        	PUSH    R28
       		PUSH    R29

        	LDI     R28,Scale_0_Type        ;First of 5 locations used for scale type data  (As used in setup mode value 0 - 5)
		LDI		R29,0x00				; Y register high byte
        	ADD     R28,R16					;Add without carry Add in scale number
        	LDD     R16,Y+0					;Load indirect with displacement (From address pointed to by Y register (R28 & R29))

		STS		Scale_Type,R16

        	POP     R29
        	POP     R28
        	RET

; ***************************************************************************************************************
; *		Save scale type (As used in setup mode (0 - 5)							*
; *		On entry scale number is in Scale_Number	Scale type is in Scale_Type			*
; *														*
; *														*
; ***************************************************************************************************************
Save_Scale_Type:

		PUSH    R28
        	PUSH    R29
;		RJMP	Save_ST_01


;Save_Scale_Type_b:		;Alternate entry with Scale number in R16, Scale type in R17
;		PUSH    R28
;        	PUSH    R29
;		RJMP	Save_ST_02

;Save_ST_01;
		LDS		R16,Scale_Number
		LDS		R17,Scale_Type

;Save_ST_02:
        	LDI     R28,Scale_0_Type        ;First of 5 locations used for scale type data  (As used in setup mode value 0 - 5)
		LDI		R29,0x00				; Y register high byte
        	ADD     R28,R16					;Add without carry Add in scale number
        	STD		Y+0,R17					;Load indirect with displacement (From address pointed to by Y register (R28 & R29))

        	POP     R29
        	POP     R28
        	RET




;			******************** end of setup code ***********************
Normal_Mode:
			
		SBI		DDRD,5			;Set PORTD bit 5 back to be an output

		RCALL	Load_Scale_Types


;        Set required scales to fast sample mode (Only applies to type 1 (2 * 24 bit) scales

		RCALL	Delay_5_Sec		;Give scales time to be ready to be set to fast mode

Scale_0_F_Tst:
		LDS		R16,Scale_0_Type
		ANDI	R16,0xBF		; Mask off bit 6 (Relative data flag)
		CPI		R16,0x81		;Is it scale type 1 and is bit 7 set ?
		BRNE	Scale_1_F_Tst
		LDI		R16,0x00		;Scale 0
		RCALL	Test_Fast_Mode	;"N" flag will be clear if already in fast mode
		BRPL	Scale_1_F_Tst
		RCALL	Set_fast_mode

Scale_1_F_Tst:
		LDS		R16,Scale_1_Type
		ANDI	R16,0xBF		; Mask off bit 6 (Relative data flag)
		CPI		R16,0x81		;Is it scale type 1 and is bit 7 set ?
		BRNE	Scale_2_F_Tst
		LDI		R16,0x01		;Scale 1
		RCALL	Test_Fast_Mode		;"N" flag will be clear if already in fast mode
		BRPL	Scale_2_F_Tst
		RCALL	Set_fast_mode

Scale_2_F_Tst:
		LDS		R16,Scale_2_Type
		ANDI	R16,0xBF		; Mask off bit 6 (Relative data flag)
		CPI		R16,0x81		;Is it scale type 1 and is bit 7 set ?
		BRNE	Scale_3_F_Tst
		LDI		R16,0x02		;Scale 2
		RCALL	Test_Fast_Mode		;"N" flag will be clear if already in fast mode
		BRPL	Scale_3_F_Tst
		RCALL	Set_fast_mode

Scale_3_F_Tst:
		LDS		R16,Scale_2_Type
		ANDI	R16,0xBF		; Mask off bit 6 (Relative data flag)
		CPI		R16,0x81		;Is it scale type 1 and is bit 7 set ?
		BRNE	Setup_Fast_End
		LDI		R16,0x03		;Scale 3
		RCALL	Test_Fast_Mode		;"N" flag will be clear if already in fast mode
		BRPL	Setup_Fast_End

Setup_Fast_End:
		RCALL	Config_PWM				;Start IG_Clock generation

		SBI	UCSRB,RXCIE		;Enable UART RX interrupt

		SEI		              ;Global Interrupt Enable




		;			------------- Start of the main program loop -------------
Main_Loop:
  
		;Deal with scale 0
		LDS		R16,Scale_0_Type
		ANDI	R16,0x0F		;Mask off flag bits
        	TST     R16             ;Test for Zero or Minus
        	BREQ    Main01			;If no scale 0 configured
        	LDI     R16,0x00        ;Select scale 0
       		RCALL   Common_Read_Scale		;Read from interface  and output value (From "r" command )

		;Deal with scale 1
Main01:
		LDS		R16,Scale_1_Type
		ANDI	R16,0x0F		;Mask off flag bits
        	TST     R16             ;Test for Zero or Minus
       	 	BREQ    Main02			;If no scale 1 configured
        	LDI     R16,0x01        ;Select scale 1
        	RCALL   Common_Read_Scale		;Read from interface  and output value (From "r" command )

		;Deal with scale 2
Main02:
		LDS		R16,Scale_2_Type
		ANDI	R16,0x0F		;Mask off flag bits
        	TST     R16             ;Test for Zero or Minus
        	BREQ    Main03			;If no scale 2 configured
        	LDI     R16,0x02        ;Select scale 2
        	RCALL   Common_Read_Scale		;Read from interface  and output value (From "r" command )

		;Deal with scale 3
Main03:
		LDS		R16,Scale_3_Type
		ANDI	R16,0x0F		;Mask off flag bits
        	TST     R16             ;Test for Zero or Minus
        	BREQ	Main_Tacho		;If no scale 3 configured
        	LDI     R16,0x03        ;Select scale 3
        	RCALL   Common_Read_Scale		;Read from interface  and output value (From "r" command )

		;Check if new tacho value needs to be displayed.
Main_Tacho:
	;Check tacho flag bit
		LDS		R16,Tacho_Flags
		SBRS	R16,0					;Display Tacho flag bit
       		RJMP    Main_Loop		;(Loop)
;Clear tacho flag
		CBR	R16,0x01
		STS	Tacho_Flags,R16

;		RCALL	Delay_300mS				;TEST ONLY

		LDI	R16,'t'					;ASCII "t"  (Start of tacho data)
  		RCALL	USART_TX

		RCALL	Format_Tacho_Out			;Output data if flag bit was set
;Sent terminate string character
		LDI	R16,';'	
		RCALL	USART_TX

        	RJMP    Main_Loop		;(Loop)

		;			--------  End of the main program loop ---------------

				
; ***************************************************************************************************************
; *	Read from interface  and output value 									*
; *	On entry R16 contains current scale number								*
; *														*
; *														*
; ***************************************************************************************************************
Common_Read_Scale:

		PUSH    R17	
        	PUSH    R18	

		STS		Scale_Number,R16
        	MOV     R17,R16					;(Scale number)
        	RCALL   Prep_for_Read			;Clears registers used in reading data from scales & loads Scale_Bit_Count, Scale_Bit_Mask
										;and bits 5 - 0 (Number of bits in a frame +1) in R2
	

		; Put test here for "HF" scale type. If "HF" scale then use section of code that looks for clock low instead of clock high

Inverted_Data_Test:						
		LDS		R16,Scale_Type
		ANDI	R16,0x0F			;Mask of top nibble
		CPI		R16,0x05			;Angle gauge
		BREQ	INV_Read_Scale
		CPI		R16,0x04			; iGaging scale type
		BREQ	IG_Read
		CPI		R16,0x03			;BIN6 scale type
		BRNE	Read_Scale

		;                ++++++++++++  START OF CODE THAT ACTUALY READS A BIN 6 TYPE SCALE  +++++++++++++++
		;								This is also used to read Angle gauge

INV_Read_Scale:										;   ***** Waiting for inter frame gap *******

       		RCALL   INV_Wait_Clock_Low			; Wait for scale clock to go to logic low (This is +1.5 V)
		BRPL	INV_Read_S02				;(This flag was set in subroutine Inv Wait_Clock_Low:) to Read_S02
	

		RJMP	Timeout_Exit			;(Timeout message and exit subroutine)
									
								; **** Now in the inter frame gap - Wait for First transition of frame *******
INV_Read_S02:
        	RCALL   INV_Wait_Clock_High			;Wait for scale clock to go high  (About 4.5 Sec)
		BRPL	INV_Read_S03			;Branch if plus  to  Read_S03 (Timeout message and exit subroutine)
		


		RJMP	Timeout_Exit			;Jump to J0135 (Timeout message and exit subroutine)

								;   ******* Start of frame detected - enable interrupts so data can be clocked in *****
INV_Read_S03:

		LDS		R16,Scale_bit_mask
		ANDI	R16,0x0F		;Mask for clock bits
		OUT     PCMSK,R16				;Out to I/O location  (PCMSK) Pin change interrupt mask (Clock) (Bits 0 - 3 used)				
   								;Enable pin change intrrupts for current scale


      		RCALL   INV_Wait_Clock_Low			;Wait for input inter frame gap to be detected again (End of data frame)

							;  *****  Now past end of frame so disable scale interrupts ******

        	LDI     R16,0x00	
        	OUT     PCMSK,R16				;(PCMSK) Pin change interrupt mask
							
			;                            ***** R8 - R3 now contain raw data read from scale ********

			;   +++++++++++++  END OF CODE THAT ACTUALY READS BIN6 SCALES  ++++++++++++++

		RJMP	Read_S04

		;      ++++++++++++++   START OF CODE THAT ACTUALY READS 2 X 24 BIT AND 7BCD TYPE SCALES +++++++++++++

Read_Scale:											;   ***** Waiting for inter frame gap *******
        	RCALL   Wait_Clock_Low			;Wait for scale clock to go low
		BRPL	Read_S02				;(This flag was set in subroutine Inv Wait_Clock_Low:) to Read_S02


		RJMP	Timeout_Exit			;(Timeout message and exit subroutine)

										; **** Now in the inter frame gap - Wait for First transition of frame *******
Read_S02:
        	RCALL   Wait_Clock_High			;Wait for scale clock to go high (About 4.5 Sec)
		BRPL	Read_S03				;(Timeout message and exit subroutine)
		RJMP	Timeout_Exit			;(Timeout message and exit subroutine)

									;   ******* Start of frame detected - enable interrupts so data can be clocked in ***** (INTERRUPT ROUTINE CALLED Pin_change_Int )
Read_S03:
		LDS		R16,Scale_bit_mask
		ANDI	R16,0x0F		;Mask for clock bits
		OUT     PCMSK,R16				;Out to I/O location  (PCMSK) Pin change interrupt mask (Clock) (Bits 0 - 3 used)
														;Enable pin change intrrupts fo current scale

        	RCALL   Wait_Clock_Low			; Wait for input bit to go low

										;  *****  Now past end of frame so disable scale interrupts ******
        	LDI     R16,0x00	
        	OUT     PCMSK,R16				;(PCMSK) Pin change interrupt mask

						;                            ***** R8 - R3 now contain raw data read from scale ********

						;  ++++++++++ END OF CODE THAT ACTUALY READS 2 X 24 BIT AND 7 BCD SCALES  ++++++++


		RJMP	Read_S04

IG_Read:					;Read data from iGaging type scale

		CPI		R22,0x43	;This will be the value just before the start of a data frame. 
		BRNE	IG_Read				;(Incremented by Timer 0 interrupt routine. Set back to zero when it reaches 0x45. A value of 0 is the start of a frame of data)

		LDS		R16,IG_Flags
		SBR		R16,0x01				;Set read request flag
		STS		IG_Flags,R16

IG_Read_Loop:
		LDS		R16,IG_Flags
		SBRC	R16,0					;Request read bit  (Cleared by Timer 1 interrupt routine )
		RJMP	IG_Read_Loop
									;Frame of 21 bit data read. NOTE in top 21 bits of 24 bit value

IG_Adjust_data:							;Rotate right 3 more positions
		CLC								;Clear Carry
		ROR     R5						;Rotate Right Through Carry Rotate carry bit 
      		ROR     R4
      		ROR     R3

		CLC								;Clear Carry
		ROR     R5						;Rotate Right Through Carry Rotate carry bit 
      		ROR     R4
      		ROR     R3

		CLC								;Clear Carry
		ROR     R5						;Rotate Right Through Carry Rotate carry bit 
      		ROR     R4
      		ROR     R3
										;Data now in the correct position in bottom 21 bits of R5 - R3

										;Now extend sign bit
		SBRS	R5,4					;Top bit of 21 bit data	
		RJMP	Read_S04	
		LDI		R16,0xE0				;Or 0xF0 would achive the same result as bit 4 is already set
		OR		R5,R16					;Set top 3 bits	

Read_S04:								; Common point after reading selected scale type
		LDS		R16,Scale_Number

Read_S05:								;Output Letters X, Y, Z or W (Depending on scale nimber) before the output value for that axis
		LDI		R16,'x'					;ASCII "x"
		ADD		R16,R17					;R17 contains scale number. Add to ASCII to make x, y, z	or if scale 3 then 0x7B 
		CPI		R16,0x7B				;   Value of ASCII character after "z"
		BRBC	1,Not_Scale3						;Skip if bit 1 (Z bit ) in status register is set  
		LDI		R16,'w'					;ASCII "w"  
Not_Scale3:
        	RCALL   USART_TX				; (Scale letter x, y, z, or w )

		LDS		R16,Scale_Type
		ANDI	R16,0x0F				;Mask off top nibble
		CPI		R16,0x2					;7 BCD scale type

        	BREQ    Scale_BCD_Out

		CPI		R16,0x01				;2 * 24 scale type
        	BREQ    Scale_2x24_Out			;Branch if equal

;	put test here for BIN6 (HF) scales 

		CPI		R16,0x03				;BIN6	scale type
		BREQ	Scale_BIN6_out

		CPI		R16,0x04			;iGagaing	scale type  (21 bit protocol)
		BREQ	Scale_IG_out

		CPI		R16,0x05			;Angle gauge scale type
		BREQ	Angle_G_out


        	RJMP    Terminate_OP_String				; SHOULD NOT GET HERE

Scale_BIN6_out:

;		RCALL	Raw_Output				;JUST FOR TESTING
		RCALL	Format_BIN6_Out
		RJMP	Terminate_OP_String

Scale_BCD_Out:
		RCALL	Format_BCD_Out
		RJMP	Terminate_OP_String


	;									***** Come here for 2 * 24 bit scale ********
Scale_2x24_Out:	
		RCALL	Format_2x24_Out	 
		RJMP	Terminate_OP_String

		;								***** Come here for iGaging (21 bit) bit scale ********
Scale_IG_out:
		RCALL	Format_IG_Out
	;	RCALL	Raw_Output
		RJMP	Terminate_OP_String

		;								***** Come here for angle gauge
Angle_G_out:
		RCALL	Format_Angle_G_Out


Terminate_OP_String: 
		LDI		R16,';'	
		RCALL	USART_TX
        	RJMP    Read_Scale_exit	

Timeout_Exit:		

Read_Scale_exit:
        	POP     R18	
        	POP     R17		
        	RET		

; ***************************************************************************************************************
; *	Clears registers used in reading data from scales and sets clock mask bit for scale 			*
; * 	On entry R16 contains scale number 									*
; *	On exit R9  & Scale_bit_mask contains the mask bit pattern  for current scale number 	 		*
; *	On exit R2 and SROM location Scale_bit_count contains Number of bits +1 for current scale type		*
; *														*
; *														*
; ***************************************************************************************************************

Prep_for_Read:
       		PUSH    R17	
        	PUSH    R18		

		LDI     R17,0x11			;Bit zero Scale 0 clock bit and data bit mask position This will now be rotated to the correct position
        	MOV     R18,R16				;Scale number Save for later

Prep_R01:
        	CPI     R16,0x00			;Compare with immediate When R16 = 0 then mask bit is in correct position
        	BREQ    Prep_R02
        	ROL     R17					;Rotate Left Through Carry rotate to next scale clock bit position
        	DEC     R16	
        	RJMP    Prep_R01	

Prep_R02:
        	MOV     R9,R17				;Bit mask for the scale clock bit to be read
		STS		Scale_bit_mask,R17
 
        	CLR     R1
        	CLR     R3
        	CLR     R4
        	CLR     R5
        	CLR     R6
        	CLR     R7
        	CLR     R8
        	MOV     R16,R18				;Set R16 back to scale number

		RCALL   Get_Scale_Type	
		ANDI	R16,0x0F			;Mask off flag bits
Prep_R03:
		CPI		R16,0x01			; 2 * 24 scale type
		BRNE	Prep_R04
		LDI		R16,0x31			;Number of bits + 1 for 2 * 24 scale
		RJMP	Prep_R07

Prep_R04:
		CPI		R16,0x02			; 7 BCD scale type
		BRNE	Prep_R05
		LDI		R16,0x1D			;Number of bits + 1 for 7 BCD scale
		RJMP	Prep_R07

Prep_R05:							;Must be type 3
;		CPI		R16,0x03			; BIN6 scale type
;		BRNE	Prep_R06
		LDI		R16,0x19			;Number of bits + 1 for BIN6  scale
;		RJMP	Prep_R



;		ANDI	R16,0x3F			;Mask of bits 6 and 7 so R16 only contains number of bits in frame +1 (Bit 6 indicates scale using external clock
									;Bit 7 indicates scale with inverted data signal)
Prep_R07:
		STS		Scale_bit_count,R16
		MOV     R2,R16				;Bit count
        	POP     R18		
        	POP     R17	
        	RET		

; ***************************************************************************************************************
; *	Outputs 2 digit (BCD) value fro R16									*
; *	Input value in R16											*
; * 		BYTE_Out	entry gives leading zero blanking						*
; * 		BYTE_Out_1  entry gives no leading zero blanking						*
; *														*
; *	 LZBF Flags bit 6 is leading zero blanking flag								*
; *														*
; ***************************************************************************************************************
BYTE_Out_1:
        	PUSH    R17	
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag
		STS		Flags,R17
        	MOV     R17,R16				;Saves value of input byte
		RJMP	BYTE_O_01
BYTE_Out:
        	PUSH    R17		

        	MOV     R17,R16				;Copy register Saves value for low nibble
BYTE_O_01:
        	SWAP    R16					;Swap nibbles
        	RCALL   Low_Nibble_OP		;Relative call subroutine  to 0x01F0 Output high nibble 
        	MOV     R16,R17				;Copy register
        	RCALL   Low_Nibble_OP		;Relative call subroutine  to 0x01F0  Output low nibble

        	POP     R17		
        	RET	

; ***************************************************************************************************************
; *	Outputs low nibble or high nibble of R16 as ASCII character		(Depending on entry point	*
; * 	Input value in R16											*
; *														*
; *	Only called twice											*
; *														*
; ***************************************************************************************************************

High_Nibble_OP:
		PUSH	R17
		SWAP    R16					;Swap nibbles
		RJMP	LN00

Low_Nibble_OP:
		PUSH	R17
LN00:
        	CLC							;Clear Carry
        	ANDI    R16,0x0F			;Mask for bottom nibble
		BRNE	LN01				; Z will be set if nibble is zero 
		LDS		R17,Flags			;Get leading zero blanking flag LZBF
		SBRC	R17,6				;Skip if LZBF is clear
		RJMP	LN04				;Exit			
		RJMP	LN02

LN01:
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag
		STS		Flags,R17
LN02:   	SBCI    R16,0xD0			;Convert to ASCII value
        	CPI     R16,0x3A			;(One more than the  ASCII value of "9") Test for value greater than 9 ?
        	BRCS    LN03				;(If value 0 - 9)
        	SBCI    R16,0xD9			;(If value A - F)
LN03:
        	RCALL   USART_TX
LN04:	
		POP		R17
        	RET		

; ***************************************************************************************************************
; *	Called onece at start of program									*
; *		Initialize I/O ports										*
; * 														*
; *														*
; ***************************************************************************************************************

Init_IO:

				;Disable all pull up resistors
;		LDI		R16,0x80	;Bit 7 is PUD bit
;		OUT		MCUCR,R16	;Set disble pull up bit
	
				;Setup PORTB		(Used for data from scales.)
        	SER     R16             ;Set to 0xFF
        	OUT     PORTB,R16		;(Will set all bits to a "1" state
        	LDI     R16,0x00        ;sets all pins as inputs
        	OUT     DDRB,R16		;(Data direction register)

				;Setup pin change interrupts
        	LDI     R16,0x00        ;(All interrupt on change disabled)
        	OUT     PCMSK,R16		; Pin change interrupt mask
        	LDI     R16,0x20        ; Bit 5 Pin change interrupt enable
        	OUT     GIMSK,R16		;(General Interrupt Mask)



				;Setup PORTD  (PORTD only has bits 0 - 6)
        	LDI     R16,0xDF        ;This will enable pull ups as pins are initialy set as inputs on bits  0,1,2,3,4,6,7
        	OUT     PORTD,R16
		LDI     R16,0x5C        ;Load immediate Bits 6,4,3,2 as outputs  Bits 0 & 1 as inputs (These are used by USART0) Bit 5 is being initialy set as input
								;to read startup mode jumper.

        	OUT     DDRD,R16	;(Data direction register)
		LDI		R16,0x40	;Just bit 6 set (MUX inhibit)
		OUT		PORTD,R16
	;	SBI		PORTD,6		;Set MUX Inh high  (Probably not reqired as it was set  when pins were set as inputs.)

        	RET   


; ***************************************************************************************************************
; *Called once at start of program.										*
; *	Configure timer 0 & 1 to use prescaler value of 1/256							*
; * 	No input or output parameters										*
; *														*
; *														*
; ***************************************************************************************************************

Set_Timer_Prescaler:

		;Timer 0	    (8 bit) (Used for iGaging clock generation)
		LDI     R16,0x04         ;  Bit 2 I/O clock /256 =20 *10^6 /256 = 78125 Hz  (12.8 uS period)
		OUT		TCCR0B,R16	

		;Timer 1
        	LDI     R16,0x04         ; Bit 2 I/O clock /256 =20 *10^6 /256 = 78125 Hz  (12.8 uS period)
		OUT     TCCR1B,R16	 ;Timer/counter 1 control reg B
;							This means timer 1 will overflow every 65536 * 12.8 = 839 mS


        	RET   

; ***************************************************************************************************************
; *	Wait for scale clock bit to go low and stay low for about 33.75 uS					*
; *   Looking for inter record gap ?										*
; * 														*
; *	If it takes too long then ( About 23 mS.) set timeout flag (Negative bit)				*
; * Should not have to wait much more than the length of a frame of data.					*
; *	Negative Bit used as output indicator flag  (Timeout if set)						*
; *														*
; ***************************************************************************************************************
Wait_IFG:
Wait_Clock_Low:				;Wait for inter frame gap
        	PUSH    R16	
        	PUSH    R18	
        	PUSH    R19		
        	PUSH    R21	

        	LDI     R19,0x00			;Used a low byte of counter
       	 	LDI     R21,0x00			;Used a low byte of counter

Wait_CL01:
        	INC     R19	
        	BRNE    Wait_CL02	
        	INC     R21	
        	BREQ    Wait_CL04	

Wait_CL02:
        	LDI     R18,0x00			;(Used as loop counter in the following loop.)

Wait_CL03:
        	IN      R16,PINB	         ; scale input
		ANDI	R16,0x0F			;Mask for clock bits
        	AND     R16,R9				 ;Logical AND (Mask for active scale ) (Clock signal bit) (Wait for signal to go low.)
        	BRNE    Wait_CL01			;  Loop  About 7 instructions in loop. Time about 7 * 65536 * 50 nS = 23 mS (Branch if input high.)
		;Signal is now low
        	LDI     R19,0x00			;Clear R19 & R21  ie restart count  (Input bit is now low.)
        	MOV     R21,R19		
        	INC     R18		
        	CPI     R18,0x4B			;(0x4B = Decimal 75)  (75 * 450 nS = 33.75 us
        	BREQ    Wait_CL05			;Good exit ?
        	RJMP    Wait_CL03			;75 times around loop  Loop is about 9 instructions time = 9 * 50 nS = 450 nS
									;75 * 450 nS = 33.75 uS
Wait_CL04:
        	SEN							;Set Negative Flag  (Timeout if set)
        	RJMP    Wait_CL06	

Wait_CL05:
        	CLN							;Clear Negative Flag
Wait_CL06:
        	POP     R21	
        	POP     R19	
        	POP     R18		
        	POP     R16	
        	RET		
	
; ***************************************************************************************************************
; *	Wait for scale clock bit to go high and stay  for about 3 mS 		For active low signal		*
; *   Looking for inter record gap ?										*
; * 														*
; *	If it takes too long then ( About 23 mS.) set timeout flag (Negative bit)				*
; * Should not have to wait much more than the length of a frame of data.					*
; *	Negative Bit used as output indicator flag  (Timeout if set)						*
; *														*
; ***************************************************************************************************************

INV_Wait_IFG:
INV_Wait_Clock_Low:					;Wait for inter frame gap
        	PUSH    R16	
        	PUSH    R18
        	PUSH    R19	
        	PUSH    R21	

	;	CBI		PORTD,2				;TEST Clear unused bit on PORTD to see if code gets here !!!


        	LDI     R19,0x00			;Used a low byte of counter
        	LDI     R21,0x00			;Used a low byte of counter

INV_Wait_CL01:
        	INC     R19	
        	BRNE    INV_Wait_CL02
        	INC     R21	
        	BREQ    INV_Wait_CL04		;Too much time elapsed Set neg flag and exit

INV_Wait_CL02:
        	LDI     R18,0x00			;(Used as loop counter in the following loop.)


									;Need this loop to timeout after about 1 mS
									; 1 mS / 256 =  about 4 us to need the loop to be 4 us long or 4 * 20  = 80 instructions
									; There are 9 instructuins in the loop so need an extra 71 instructions
INV_Wait_CL03:
        	IN      R16,PINB			;scale input
		ANDI	R16,0x0F			;Mask for clock bits
        	AND     R16,R9				;(Mask for active scale ) (Clock signal bit) (Wait for signal to go low.) (Active low)
        	BREQ    INV_Wait_CL01		; About 7 instructions in loop. Time about 7 * 65536 * 50 nS = 23 mS (Branch if input high.) !!!!!

		;Signal is now low  (Inverse sense so will be + ve level)

        	LDI     R19,0x00			;Clear R19 & R21  ie restart count  (Input bit is now low.)
        	MOV     R21,R19	
        	INC     R18	

     ;   	CPI     R18,0x4B			;(0x4B = Decimal 75)  (75 * 450 nS = 33.75 us

		CPI		R18,0xFF
		BREQ    INV_Wait_CL05		;Good exit ?
		RCALL	Delay_71			;Delay about 71 instructions

        	RJMP    INV_Wait_CL03		;75 times around loop  Loop is about 9 instructions time = 9 * 50 nS = 450 nS
INV_Wait_CL04:
        	SEN							;Set Negative Flag  (Timeout if set)
        	RJMP    INV_Wait_CL06	
INV_Wait_CL05:
        	CLN							;Clear Negative Flag
INV_Wait_CL06:

	;	SBI		PORTD,2			;TEST Set unused bit on PORTD to see if code gets here !!!

        	POP     R21	
        	POP     R19	
        	POP     R18	
        	POP     R16	
        	RET	

; ***************************************************************************************************************
; *  Delay about 71 Instructions										*
; *  RCALL (1), PUSH (1), POP (1), RET (1)  take up 4 instruction so need another 67				*
; *														*
; ***************************************************************************************************************
Delay_71:
		PUSH	R16
		LDI		R16,33
Del71_01:	
		DEC		R16
		BRNE	Del71_01
		POP		R16
		RET

; ***************************************************************************************************************
; *	Wait for scale clock to go high										*
; * 														*
; *	If it takes too long then ( About 500 mS.) set timeout flag (Negative bit)				*
; *	Negative Bit used as output indicator flag  (Timeout if set)						*
; *	R18, R19 and R20 being used as a counter in this routine						*
; ***************************************************************************************************************

Wait_Clock_High:
        	PUSH    R18		
        	PUSH    R19		
        	PUSH    R20		
        	PUSH    R16		

        	LDI     R18,0x89			; These three locations are a timer  (This is low byte)
       	 	LDI     R19,0x7B			; (This is middle byte)
        	LDI     R20,0xE1			;(This is high byte)   5 instructions * 0.05 uS = 0.25 uS   for 500 ms timeout 500000/0.25 = 2000000 = 0x1E8480 
Wait_CH01:															; 0x1000000 - 0x1E8480 = 0xE17B89
        	IN      R16,PINB			;Scale input
		ANDI	R16,0x0F			;mask for clock bit
        	AND     R16,R9				;Mask for active scale clock signal)
        	BRNE    Wait_CH02			;(Good exit) When input is high)
        	INC     R18			
        	BRNE    Wait_CH01	
        	INC     R19		
        	BRNE	Wait_CH01	
        	INC     R20	
        	BRNE    Wait_CH01	
        	SEN							;Set Negative Flag    (Indicates timeout )
        	RJMP    Wait_CH03	
Wait_CH02:
        	CLN							;Clear Negative Flag     (Good exit)
Wait_CH03:
        	POP     R16		
        	POP     R20		
        	POP     R19		
        	POP     R18		
        	RET	

; ***************************************************************************************************************
; *	Wait for scale clock to go low 				For active low signal				*
; * 														*
; *	If it takes too long then ( About 500mS ) set timeout flag (Negative bit)				*
; *	Negative Bit used as output indicator flag  (Timeout if set)						*
; *	R18, R19 and R20 being used as a counter in this routine						*
; ***************************************************************************************************************

INV_Wait_Clock_High:
       		PUSH    R18		
        	PUSH    R19		
        	PUSH    R20		
        	PUSH    R16	

		LDI     R18,0x89			; These three locations are a timer  (This is low byte)
        	LDI     R19,0x7B			; (This is middle byte)
        	LDI     R20,0xE1			;(This is high byte)   5 instructions * 0.05 uS = 0.25 uS   for 500 ms timeout 500000/0.25 = 2000000 = 0x1E8480 															; 0x1000000 - 0x1E8480 = 0xE17B89


Inv_Wait_CH01:
        	IN      R16,PINB			;Scale input
		ANDI	R16,0x0F			;mask for clock bit
        	AND     R16,R9				;Logical AND  Mask for active scale clock signal)
        	BREQ    Inv_Wait_CH02		;(Good exit) When input is logic high which is low level with inverted signal)
        	INC     R18	
        	BRNE    Inv_Wait_CH01	
        	INC     R19		
        	BRNE    Inv_Wait_CH01	
        	INC     R20	
        	BRNE    Inv_Wait_CH01	
        	SEN							;Set Negative Flag    (Indicates timeout ?)
        	RJMP    Inv_Wait_CH03
Inv_Wait_CH02:
        	CLN							;Clear Negative Flag     (Good exit)
Inv_Wait_CH03:
        	POP     R16	
        	POP     R20	
        	POP     R19	
        	POP     R18	
        	RET		

; ***************************************************************************************************************
; *		Initialize USART										*
; *														*
; ***************************************************************************************************************

USART_Init:
        	LDI     R16,0x40        ;(0x40 = 64)   baud rate = 20 * 10^6/(16(64 +1)) = 20 * 10^6/1040 = 19230.8 bauds
        	OUT     UBRRL,R16		;Usart baud rate register low
        	LDI     R16,0x06        ;Value gives 8 bit character size
        	OUT     UCSRC,R16		;Usart control and status register C
        	LDI     R16,0x18        ;Bits 3,4 Rx enable , TX enable, 
       	 	OUT     UCSRB,R16		; Usart control and status register B
        	RET    


; ***************************************************************************************************************
; *	Output string of text from program memory to serial port						*
; * 	Pointer to string in r30 (Low byte) and r31 (High byte) Divide this 16 bit value by 2   		*
; *	These two registers form the 16 bit Z register								*
; *	to give program memory address in the listing.								*
; *T_String													*
; ***************************************************************************************************************

T_String:
        	PUSH	R16
T_String_Loop:
        	LPM				;Load program memory (Loads one byte pointed to by the Z-register into the destination register Rd.)
;						(Destination Reg R0 implied as no destination specified)
        	TST     R0			;Test for Zero or Minus
        	BREQ    T_String_Exit	
        	MOV     R16,R0
        	RCALL   USART_TX
        	ADIW    R30,0x01		;Add immediate to word
        	RJMP    T_String_Loop

T_String_Exit:
        	POP     R16
        	RET

; ***************************************************************************************************************
; *	Interupt handler for pin change interrupt								*
; * 														*
; *	R1 is incremented each time through this routine							*
; * R2 initialy contains the number of bits + 1 to receive from the scale (BCD 29, 2 x 24 49) is decremented	*
; * each interrupt reading complete when it reaches zero							*
; *    I think at end of frame R1 contains the number of bits +1 						*
; *     R1 is set to initial value of 0x00 is subroutine S01C3							*
; *														*
; ***************************************************************************************************************

Pin_change_Int:

		PUSH    R16		
        	PUSH    R17	
		PUSH	R18

        	IN      R11,SREG			;Save STATUS in location R11 during interrupt

		; Put test here for "HF" scale type. If "HF" scale then use section of code that looks for clock low instead of clock high
		; "HF" scale will  24 bits + 1 = 25  = 0x19  and bit 7 set to indicate inverted signals = 0x99 
		;Alternative code

		LDS		R16,Scale_Type
		CPI		R16,0x03			;BIN6 scale type. Their signal is inverted.
		BRNE	Pin_ch01			;Deal with inverted signal levels.	

		IN      R16,PINB			;Scale input
        	MOV     R12,R16	
		ANDI	R16,0x0F			;Mask for clock bits
        	AND     R16,R9				;R9 contains mask bits for current scale 
        	BREQ    Pin_ch05			;Branch if not equal (Exit if clock bit not set )  (Interrupt may occur on both edges so ignore if clock high )
		RJMP	Pin_ch02

		;   Possible change to code. Use XOR mask to invert input from PINB	when using an inverted data type scale (BIN6)

Pin_ch01:
        	IN      R16,PINB			;  Scale input
        	MOV     R12,R16		
		ANDI	R16,0x0F			;Mask for clock bits
        	AND     R16,R9				;R9 contains mask bit for current scale clock bit 
        	BRNE    Pin_ch05			;Branch if not equal (Exit if clock bit not set )  (Interrupt may occur on both edges so ignore if clock low )

Pin_ch02:
        	DEC     R2					;Bit number counter (Config value contains number of bits in frame +1)
        	BREQ    Pin_ch04			;Clear PCMSK to prevent any more interrupts when required number of bits have been read.                                        
        	CLC							;Clear Carry

		MOV		R16,R12
		ANDI	R16,0xF0			;Mask for data bits
		AND     R16,R9				;R13 contains PORTB input value R9 contains scale mask bits

        	BREQ    Pin_ch03			;(If data bit is zero)
        	SEC							 ;Set Carry

Pin_ch03:
;
      		ROR     R8					;Rotate Right Through Carry Rotate carry bit into 48 bit value (2 x 24 bit) MSB
      		ROR     R7
      		ROR     R6	
      		ROR     R5	
      		ROR     R4	
      		ROR     R3					;Rotate Right Through Carry	LSB

      		RJMP    Pin_ch05

Pin_ch04:
        	OUT     PCMSK,R2			;Pin change interrupt mask This will clear it as R2 now = 00 So no scales will interrupt
Pin_ch05:
        	OUT     SREG,R11			;Restore STATUS from location R11
		POP		R18
		POP     R17	
        	POP     R16	
        	RETI	

; ***************************************************************************************************************
; *	Interrupt handler for USART0 RX complete interrupt							*
; *	Byte_Count has initial value of 0									*
; *   Receive 3 bytes of data from tach0 module. (LSB received first.)						*
; *														*
; ***************************************************************************************************************

USART_RX_Int:
        PUSH    R16
        PUSH    R17
        IN      R17,SREG
        PUSH    R18
        PUSH    R28
	PUSH	R29

	LDI	R29,0x00
        LDI     R28,Tacho_L	;Y register low byte
    	LDS     R16,Byte_Count    ;  (Byte counter)
	ADD     R28,R16          ;Add without carry. Points to location to store byte
        IN      R18,UDR		; Usart data register (This also clears the interrupt flag)
        STD     Y+0,R18          ;Store received byte 
        INC     R16              ;Increment To next byte position

	CPI     R16,0x03         ;Compare with 0x3 was it the third byte bytes of Tacho data
        BRNE    Not_Last
	LDI	R16,0x00         ;Reset counter  This was the last byte of the 24 bit word
	STS     Byte_Count,R16       ;Save new value
	LDI	R16,0x01	;Set bit 0 (Only this bit used.)
	STS	Tacho_Flags,R16	; Bit 0 set indicates new reading to ne sent to tablet.
	LDI	R16,0x00
	STS	Timer_L,R16		;Zero Tacho timeout timer
	STS	Timer_H,R16
	RJMP	RX_Exit

Not_Last:
    	STS     Byte_Count,R16       ;Save value


RX_Exit:
	POP	R29
        POP     R28 
        POP     R18   
        OUT     SREG,R17	
        POP     R17         
        POP     R16       
        RETI



; ***************************************************************************************************************
; *	Read EEPROM locations 00,01,02,03	Load scale types from EEPROM to					*
; * 	Scale_0_Type  Scale_1_Type  Scale_2_Type  Scale_3_Type							*
; * 														*
; ***************************************************************************************************************
Load_Scale_Types:
        	CLI							;Global Interrupt Disable
        	LDI     R17,0x00			;EEPROM address to read from 
        	RCALL   Read_EEprom	
    		STS     Scale_0_Type,R16			
        	LDI     R17,0x01			;EEPROM address to read from 
       	 	RCALL   Read_EEprom	
    		STS     Scale_1_Type,R16			
        	LDI     R17,0x02			;EEPROM address to read from 
        	RCALL   Read_EEprom	
    		STS     Scale_2_Type,R16			
        	LDI     R17,0x03			;EEPROM address to read from 
        	RCALL   Read_EEprom	
    		STS     Scale_3_Type,R16
		SEI			
        	RET	

; ***************************************************************************************************************
; *		Write one byte to EEPROM									*
; * 		EEPROM address to write to in 	R17								*
; *		Data to be written in R16									*
; *														*
; ***************************************************************************************************************
Write_EEprom: 
        	SBIC    EECR,1				;Eprom control register
        	RJMP    Write_EEprom	
        	OUT     EEAR,R17	        ;EEprom address register
        	OUT     EEDR,R16			;EEprom data register
        	CLI							;Global Interrupt Disable
        	SBI     EECR,2				;Eprom control register
        	SBI     EECR,1				;Eprom control register
        	SEI							;Global Interrupt Enable
        	RET	

; ***************************************************************************************************************
; *	Read one byte from EEPROM										*
; * 	EEPROM address in R17											*
; *														*
; *	Data returned in R16											*
; ***************************************************************************************************************
Read_EEprom:
        	SBIC    EECR,1				;Eprom control register
        	RJMP    Read_EEprom	
        	OUT     EEAR,R17			;EEprom address register
        	SBI     EECR,0				;EEprom control register
        	IN      R16,EEDR			;EEprom data register
        	RET		

; ***************************************************************************************************************
; *	USART Transmit												*
; * Output ASCII character in R16 to serial out									*
; *		R16 unchabged											*
; *														*
; ***************************************************************************************************************
USART_TX:
        	SBIS    UCSRA,5				;Usart control and status register A
        	RJMP    USART_TX		
        	OUT     UDR,R16		
        	RET		

; ----------------------------------------------------------------------------------------------------------------
;                                      Text strings in Program memory




; ***************************************************************************************************************
; *	Output text string  "Bad range is 0.3." + CR/LF								*
; *	Msg004													*
; *														*
; ***************************************************************************************************************
Message_Invalid_number:
.DB	0x0D,0x0A
.DB	" Invalid number."		;,0x00
.DB	0x0D,0x0A
.DB	0x00,0x00
;			************ Messages for setup menu ********************

; ***************************************************************************************************************
; *	"Setup mode" 												*
; *	Msg020													*
; *														*
; ***************************************************************************************************************
Setup_Msg:
.DB	0x0D,0x0A
.DB	"  !! In setup mode !!",0x00
.DB	0x0D,0x0A
.DB	0,0

; ***************************************************************************************************************
; *	Output text string  "Scale to configure (0 - 3) ? or X for Normal mode "				*
; *														*																										*
; ***************************************************************************************************************
Scale_to_conf:
.DB	0x0D,0X0A					;CR/LF
.DB	"  Scale to configure (0 - 3) ? or X for Normal mode  ",0x00
.DB 0x00,0x00

; ***************************************************************************************************************
; *text string  	"Scale types are :- "									*
; *														*																										*
; ***************************************************************************************************************
Scale_types:
.DB	0x0D,0X0A					;CR/LF
.DB	0x0A,0x0A					;LF/LF
.DB	"  Scale types are :- ",0x00
.DB	0x0D,0x0A			;CR/LF
.DB 0x00,0x00

; ***************************************************************************************************************
; * text string  	"	0 "										*
; *														*																										*
; ***************************************************************************************************************
Space_0:
.DB	0x0D,0X0A					;CR/LF
.DB	"	0  "
.DB 0x00,0x00
; ***************************************************************************************************************
; *	text string  "	1 "											*
; *														*																										*
; ***************************************************************************************************************
Space_1:
.DB	0x0D,0X0A					;CR/LF
.DB	"	1  "
.DB 0x00,0x00
; ***************************************************************************************************************
; *	 text string  	"	2 "										*
; *														*																										*
; ***************************************************************************************************************
Space_2:
.DB	0x0D,0X0A					;CR/LF
.DB	"	2  "
.DB 0x00,0x00 
; ***************************************************************************************************************
; *	text string  												*
; *														*																										*
; ***************************************************************************************************************
Space_3:
.DB	0x0D,0X0A					;CR/LF
.DB	"	3  "
.DB 0x00,0x00

; ***************************************************************************************************************
; *	text string  												*
; *														*																										*
; ***************************************************************************************************************
Space_4:
.DB	0x0D,0X0A					;CR/LF
.DB	"	4  "
.DB 0x00,0x00
; ***************************************************************************************************************
; *	text string  												*
; *														*																										*
; ***************************************************************************************************************
Space_5:
.DB	0x0D,0X0A					;CR/LF
.DB	"	5  "
.DB 0x00,0x00

; ***************************************************************************************************************
; *			 text string  	"	Not configured "						*
; *														*																										*
; ***************************************************************************************************************
Not_configured:
.DB	" Not configured "
.DB 0x00,0x00


; ***************************************************************************************************************
; *	text string  "	2 * 24 bit"										*
; *														*																										*
; ***************************************************************************************************************
Twox24:
.DB	" 2 * 24 bit",0x00
.DB 0x00,0x00


; ***************************************************************************************************************
; *	text string  	" 7 BCD"										*
; *														*																										*
; ***************************************************************************************************************
Seven_BCD:
.DB	" 7 BCD"
.DB 0x00,0x00


; ***************************************************************************************************************
; *	text string  	*BIN 6"											*
; *														*
; ***************************************************************************************************************
Bin_6:
.DB	" BIN 6"
.DB 0x00,0x00

; ***************************************************************************************************************
; *	text string  	*iGaging"										*
; *														*
; ***************************************************************************************************************
IG_21_Bit:
.DB	" iGaging  "
.DB 0x00,0x00

; ***************************************************************************************************************
; *	text string  	*Angle gauge"										*
; *														*
; ***************************************************************************************************************
Angle_Gauge:
.DB	" Angle_Gauge  "
.DB 0x00,0x00

; ***************************************************************************************************************
; *	text string  	"	Scale type ("									*
; *														*																										*
; ***************************************************************************************************************
Scale_type_Q:
.DB	0x0D,0X0A					;CR/LF
.DB	0x0D,0x0A					;CR/LF
.DB	"	Scale type (",0x00
.DB 0x00,0x00

; ***************************************************************************************************************
; *	text string  "	New type ? ( return to accept. ) 							*
; *														*																										*
; ***************************************************************************************************************
New_type:
.DB	0x0D,0X0A					;CR/LF
.DB	"	New type ? ( return to accept. ) "
.DB 0x00,0x00


; ***************************************************************************************************************
; *	text string  	"	Enable fast mode (Y) ( Y or N return to accept. ) "				*
; *														*																										*
; ***************************************************************************************************************
Enable_fast_a:
.DB	0x0D,0X0A					;CR/LF
.DB	"	Enable fast mode (",0x00
.DB 0x00,0x00

Enable_fast_b:
.DB	") ( Y or N return to accept. ) ",0x00
.DB 0x00,0x00

; ***************************************************************************************************************
; *	text string  		"	Save changes (Y or N) "							*
; *														*																										*
; ***************************************************************************************************************
Save_changes:
.DB	0x0D,0X0A					;CR/LF
.DB	"	Save this scale settings to EEPROM (Y or N) ",0x00


; ***************************************************************************************************************
; *	text string  		"	Not valid type "							*
; *														*
; ***************************************************************************************************************
Not_valid_type:
.DB	0x0D,0X0A					;CR/LF
.DB	"	Not valid type "
.DB 0x00,0x00


; ***************************************************************************************************************
; *	text string  		"	Returning to normal mode Remove setup jumper "				*
; *														*
; ***************************************************************************************************************
Return_Normal:
.DB	0x0D,0X0A					;CR/LF
.DB	"	Returning to normal mode "
.DB	0x0D,0X0A					;CR/LF
.DB	"   Remove setup jumper ! ",0x00
.DB 0x00,0x00

; ***************************************************************************************************************
; *	text string  		"	Version "								*
; *														*
; ***************************************************************************************************************
Version:
.DB	0x0D,0X0A					;CR/LF
.DB	"	6_Mode_interface_V01  07/07/14 18:16 "

.DB 0x00,0x00


; ***************************************************************************************************************
; *	text string  		"	Use absolute (a) or relative data (r) ? "				*
; *						"   Set to ( ) Select a or r (Return to accept current) " 	*
; ***************************************************************************************************************
Data_Type_a:
.DB	0x0D,0X0A					;CR/LF
.DB	"	Use absolute (a) or relative data (r) ?  "
.DB	0x0D,0X0A					;CR/LF
.DB	"   Set to (",0x00 

Data_Type_b:
.DB	") Select a or r (Return to accept current)  "
;.DB	0x0D,0X0A					;CR/LF
.DB 0x00,0x00

;		*********************************** End of text strings ***************************
; ***************************************************************************************************************
; *	Get input characters											*
; *		Wait for received character to be in buffer then move to R16					*
; *		On return R16 contains character								*
; *														*
; ***************************************************************************************************************
Uart_RX:
		SBIS UCSRA, RXC
		RJMP	UART_RX
		IN r16, UDR
		RET

; ***************************************************************************************************************
; *	Invert all 48 bits of data from 2 * 24 bit scales 							*
; *														*
; *														*
; *	Invert2x24												*
; ***************************************************************************************************************
Invert2x24:			
		COM		R3
		COM		R4
		COM		R5
		COM		R6
		COM		R7
		COM		R8
		RET

; ***************************************************************************************************************
; *	BintoBCD												*
; * Convet 24 bit binary number to 8 BCD digits									*
; * See note at start of program about Variables used in this subroutine  in SRM   			*
; *	Using registers R16, R17, R18, R19, R28, R29 Some may need to save them on the stack			*
; *														*
; * Value to be converted in Rbin0, (MSN) Rbin1, Rbin2 (LSB)							*
; * results in 	RBCD0 (MSB), RBCD1, RBCD2. RBCD3 (LSB)								*
; *														*
; ***************************************************************************************************************

BintoBCD:			
			PUSH	R28
			PUSH	R29
			LDI		R19,24		; 24-Bits Use at counter

			LDI		R16,0x00		; Clear result area
			STS		RBCD0,R16
			STS		RBCD1,R16
			STS		RBCD2,R16
			STS		RBCD3,R16
Loop:		
			LDI		R28,LOW (RBCD0) ;Set Y register to point to RBCD0
			LDI		R29,0x00    ;Required for Attiny4313 Not required as Attiny2313 has less than 256 bytes of data space
			LDI		R18,4		;use as counter

BintoBCD1:		

			LD		R17,Y		;Load inderect
			LDI		R16,0x33
			ADD		R17,R16
			ST		Y,R17		; I do not need think to save it at this point
			SBRC	R17,3		; top bit of low nibble ?  (If the original nibble was 5 or greater then adding 3 
								; will cause the top bit of nibble to be set)
			ANDI	R16,0xF0	;

			SBRC	R17,7		; top bit of high nibble ? (If the original nibble was 5 or greater then adding 3 
								; will cause the top bit of nibble to be set
			ANDI	R16,0x0F
			SUB		R17,R16
			ST		Y+,R17		;Store indirect and increment pointer
			DEC		R18			;Decrement counter (Counts down from 4)
			BRNE	BintoBCD1
			LDI		R28,LOW (Rbin2 + 1) 	;Set Y register to point to Rbin2 +1 as we are using pre decrement
			LD		R17,-Y			;Rbin LSB
			ROL		R17			; Need to save back after rotate
			ST		Y,R17
			LD		R17,-Y
			ROL		R17
			ST		Y,R17
			LD		R17,-Y
			ROL		R17
			ST		Y,R17
			LD		R17,-Y
			ROL		R17
			ST		Y,R17
			LD		R17,-Y
			ROL		R17
			ST		Y,R17
			LD		R17,-Y
			ROL		R17
			ST		Y,R17
			LD		R17,-Y
			ROL		R17
			ST		Y,R17

			DEC		R19			;Counts down from 24
			BRNE	Loop
			POP		R29
			POP		R28
			RET

; *************************************************************************************************************	*
; *	Check a 24 bit binary number. If negative then convert to positive an set negative flag			*
; *	Negative flag is bit 7 of FLAGS byte which is in SRAM							*
; *	24 bit number is in R5 (MSB) R4,   & R3	for iGaging scales and 2 * 24 bit scales when in absolute mode	*
; * 24 bit number is in R8 (MSB) R7,   & R6	for 2 * 24 bit scales when in relative mode mode.		*	
; *	Make_Positive												*
; *************************************************************************************************************	*

Make_Positive:				;	

		PUSH	R17
		LDS		R17,FLAGS
		ANDI	R17,0x7F	;Clear bit 7 (Negative flag.)

		LDS		R16,Scale_Number
		RCALL	Get_Scale_Type			;R16 now contains scale type
		SBRS	R16,6				;Skip if flag is set (Bit 6) Selects absolute or relative data (Set for rel)
		RJMP	Make_P02			;Deal with absolute data



Make_P01:					; Deal with relative frame
		SBRS	R8,7
		RJMP	Not_Neg	

				; Sample is negative so make one's complement 
		COM		R8
		COM		R7
		COM		R6

		ORI		R17,0x80	;Set bit 7 (Negative flag)


;Increment Data here to make 2's complemant or count will be wrong by 1

			INC	R6	
			BRNE	Not_Neg
			INC	R7	
			BRNE	Not_Neg
			INC	R8	

			RJMP	Not_Neg



Make_P02:					; Deal with absolute frame frame
		SBRS	R5,7
		RJMP	Not_Neg	

				; Sample is negative so make one's complement 
		COM		R5	
		COM		R4	
		COM		R3

		ORI		R17,0x80	;Set bit 7 (Negative flag)


;Increment Data here to make 2's complemant or count will be wrong by 1

			INC	R3	;
			BRNE	Not_Neg
			INC	R4	;
			BRNE	Not_Neg
			INC	R5	;

Not_Neg:
			STS		Flags,R17	;Save back in SRAM location "Flags"
			POP		R17
			RET


; ***************************************************************************************************************
; *		Output all 48 bits as two groups of 6 HEX characters						*
; *		The 49 bits (6 bytes) ar in R3 (MSB) to R8 (LSB)						*
; *														*
; *	Raw_Output												*
; ***************************************************************************************************************

			
		;Start of test code to output raw HEX data
Raw_Output:


		LDI		R16,'R'				;TEST
		RCALL	USART_TX				;TEST
		LDI		R16,'a'				;TEST
		RCALL	USART_TX				;TEST
		LDI		R16,'w'				;TEST
		RCALL	USART_TX				;TEST

		LDI		R16,0x20	;ASCII space				;TEST
		RCALL	USART_TX				;TEST











	;	LDI		R16,0x0A	;	ASCII LF
	;	RCALL	USART_TX
	;;	LDI		R16,0x0D	;	ASCII CR
	;	RCALL	USART_TX

	;	RCALL	Invert2x24				;Data from 2 * 24 scales is inverted  so correct for this. 

		LDI		R16,0x20	;	ASCII Space
		RCALL	USART_TX
		LDI		R16,0x20	;	ASCII Space
		RCALL	USART_TX
		LDI		R16,0x20	;	ASCII Space
		RCALL	USART_TX

		LDI		R21,0x00	;Clear leading zero blanking flag.
		MOV		R16,R8		;MSB								Relative data
		RCALL	BYTE_Out

		MOV		R16,R7
		RCALL	BYTE_Out

		MOV		R16,R6
		RCALL	BYTE_Out

		LDI		R16,0x20	;	ASCII Space
		RCALL	USART_TX

		MOV		R16,R5		;									Absolute data
		RCALL	BYTE_Out

		MOV		R16,R4
		RCALL	BYTE_Out

		MOV		R16,R3
		RCALL	BYTE_Out
		LDI		R16,0x0A	;	ASCII LF
		RCALL	USART_TX
		LDI		R16,0x0D	;	ASCII CR
		RCALL	USART_TX

		RET

		;End of test code to output raw HEX data

; ***************************************************************************************************************
; *		Format data from a BCD scale for output as string of ASCII characters				*
; *														*
; ***************************************************************************************************************

Format_BCD_Out:
										;Come here for BCD scale	

		PUSH	R17 
		LDS		R17,Flags
		SBR		R17,0x40			;Set leading zero blanking flag. If set does not output zero  
		STS		Flags,R17
								
		SBRS	R8,4				;Test for negative flag (Bit 4 of byte) in top nibble of BCD scale data  
		RJMP	Pos_Val
		LDI		R16,0x2D					;Output minus sign
		RCALL	USART_TX
Pos_Val:
        MOV     R16,R8				;Copy register  
  		RCALL	Low_Nibble_OP		;High nibble is only flags
        MOV     R16,R7				;Copy register  
        RCALL   BYTE_Out			;Outputs 2 digit (BCD or HEX) value from R16
        MOV     R16,R6				;Copy register 
        RCALL   BYTE_Out			;Outputs 2 digit (BCD or HEX) value from R16
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag. If set does not output zero  
		STS		Flags,R17

        MOV     R16,R5				;Copy register  Least significant byte - Only high nibble used.
		RCALL	High_Nibble_OP	
		POP		R17
		RET


; ***************************************************************************************************************
; *			Format data from a 2 * 24 bit scale for output as string of ASCII charactes		*
; *														*
; *														*
; ***************************************************************************************************************

Format_2x24_Out:	
		PUSH	R17							
		RCALL	Invert2x24				;Data from 2 * 24 scales is inverted  so correct for this. 

		RCALL	Make_Positive			;Check if value is negative (Bit 23 of 24 bit frame) If so generate 2's complement and set negative flag.

		LDS		R16,FLAGS
		TST		R16
		BRPL	Fmat_2x24_01		;Testing bit 7 . Leading zero blanking flag
		LDI		R16,'-'				;Output minus sign
		RCALL	USART_TX
Fmat_2x24_01:	
  
   ;Get top 3 bytes of input data (Relative value for testing. )

		LDS		R17,Flags
		SBR		R17,0x40			;Set leading zero blanking flag. (LZBF) If set does not output zero  
		STS		Flags,R17

									;Test if absolute or relative data is required
		LDS		R16,Scale_Number
		RCALL	Get_Scale_Type			;R16 now contains scale type
		SBRC	R16,6					;Skip if Relative bit flag is clear (Bit 6)
		RJMP	Rel_data

Abs_data:
		STS		Rbin0,R5
		STS		Rbin1,R4
		STS		Rbin2,R3
		RJMP	Change_To_BCD

Rel_data:
		STS		Rbin0,R8
		STS		Rbin1,R7
		STS		Rbin2,R6

Change_To_BCD:
		RCALL	BintoBCD			; Convert 24 bit binary value to 6 decimal digits

		LDS		R16,RBCD0
		RCALL   BYTE_Out	
		LDS		R16,RBCD1
		RCALL   BYTE_Out			;Outputs 2 digit (BCD or HEX) value from R16
		LDS		R16,RBCD2
		RCALL   BYTE_Out	
		LDS		R16,RBCD3
		RCALL	High_Nibble_OP		;Output High nibble of least significant byte 
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag. (LZBF)   so least significant "0" is output 
		STS		Flags,R17
		LDS		R16,RBCD3			;
		RCALL	Low_Nibble_OP		;Output low nibble of least significant byte even if it is zero  
		POP		R17
		RET


; ***************************************************************************************************************
; *				Format data from a BIN6 scale for output as string of ASCII charactes		*
; *														*
; *														*
; *														*
; ***************************************************************************************************************
Format_BIN6_Out:

  ;Get top 3 bytes of input data  

		PUSH	R17
		LDS		R17,Flags
		SBR		R17,0x40			;Set leading zero blanking flag. (LZBF) If set does not output zero  
		STS		Flags,R17

		MOV		R16,R8
		ANDI	R16,0x0F			;Mask off top nibble  (These bits are flags.)
		STS		Rbin0,R16
		STS		Rbin1,R7
		STS		Rbin2,R6
		RCALL	BintoBCD			; Convert 24 bit binary value to 6 decimal digits

		SBRS	R8,4				;Test for negative flag (Bit 4 of byte) in top nibble of BCD scale data  
		RJMP	Fmat_BIN6_02
		LDI		R16,0x2D					;Output minus sign
		RCALL	USART_TX

Fmat_BIN6_02:
		LDS		R16,RBCD0
		RCALL   BYTE_Out	
		LDS		R16,RBCD1
		RCALL   BYTE_Out			;Outputs 2 digit (BCD or HEX) value from R16
		LDS		R16,RBCD2
		RCALL   BYTE_Out		
		LDS		R16,RBCD3
		RCALL	High_Nibble_OP		;Output High nibble of least significant byte 
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag. (LZBF) so least significant "0" is output
		STS		Flags,R17 

		LDS		R16,RBCD3
		RCALL	Low_Nibble_OP		;Output low nibble of least significant byte even if it is zero  
		POP		R17
		RET

; ***************************************************************************************************************
; *				Format data from a iGaging scale for output as string of ASCII charactes	*
; *														*
; *														*
; *														*
; ***************************************************************************************************************


Format_IG_Out:
		PUSH	R17	
		RCALL	Make_Positive			;Check if value is negative (Bit 23 of 24 bit frame) If so generate 2's complement and set negative flag.

		LDS		R16,FLAGS
		TST		R16
		BRPL	Format_IG01			;Testing for negative flag
		LDI		R16,'-'				;Output minus sign
		RCALL	USART_TX

Format_IG01:
		LDS		R17,Flags
		SBR		R17,0x40			;Set leading zero blanking flag. (LZBF) If set does not output zero  
		STS		Flags,R17

		STS		Rbin0,R5
		STS		Rbin1,R4
		STS		Rbin2,R3

		RCALL	BintoBCD			; Convert 24 bit binary value to 6 decimal digits

		LDS		R16,RBCD0
		RCALL   BYTE_Out	
		LDS		R16,RBCD1
		RCALL   BYTE_Out			;Outputs 2 digit (BCD or HEX) value from R16
		LDS		R16,RBCD2
		RCALL   BYTE_Out	
		LDS		R16,RBCD3
		RCALL	High_Nibble_OP		;Output High nibble of least significant byte 
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag. (LZBF)   so least significant "0" is output 
		STS		Flags,R17
		LDS		R16,RBCD3			;
		RCALL	Low_Nibble_OP		;Output low nibble of least significant byte even if it is zero  
		POP		R17
		RET

; ***************************************************************************************************************
; *				Format data from a Angle gauge for output as string of ASCII charactes		*
; *														*
; *														*
; *														*
; ***************************************************************************************************************


Format_Angle_G_Out:

	;	RCALL	Raw_Output		;Use this to start with

		RCALL	Make_Positive			;Check if value is negative (Bit 23 of 24 bit frame) If so generate 2's complement and set negative flag.

		LDS		R16,FLAGS
		TST		R16
		BRPL	Format_AG01			;Testing for negative flag
		LDI		R16,'-'				;Output minus sign
		RCALL	USART_TX

Format_AG01:
		PUSH	R17
		LDS		R17,Flags
		SBR		R17,0x40			;Set leading zero blanking flag. (LZBF) If set does not output zero  
		STS		Flags,R17

		; First deal with top 16 bits

		LDI		R16,0x00		; 
		STS		Rbin0,R16			; MSB

		MOV		R16,R8
		ROR		R16
		ANDI		R16,0x3F		;Mask off top bit (I do not think it is used.) (Now in bit 6) and carry bit which will be in bit 7

		STS		Rbin1,R16

		MOV		R16,R7
		ROR		R16
		STS		Rbin2,R16		;LSB
		;May need to increment value in Rbin1, Rbin2 if requires for rounding up due to value of bits 0 - 8 of data


						;Deal with bits 0 - 7  (From R6) and bit 8 (From R7 bit 0)

		LDI		Zl,low(Lookup_Table *2)
		LDI		Zh,high(Lookup_Table *2)
		ADD		Zl,R6				; Add offset from start of table
		LPM						; load table entry to R0

		LDI		R16,0x50
		SBRC		R7,0			; This bit (Bit 8 of 24 bit value ) represents 5 degrees
		ADD		R0,R16			; Combine bit 8 with value from lookup table
		
		;Now need to check 	if top nibble of R0 is greater than 9

		MOV		R16,R0
		STS		Tenths,R16			;save value to display later
		CPI		R16,0xA0
		BRSH		Dig_Overflow				;Branch if same or higher

		RJMP		Angle_Display

Dig_Overflow:
		LDI		R16,0x00				;Set units and tenths to display zero 
		STS		Tenths,R16

		;Now increment 24 bit value in 	RBCD1 - RBCD3
		CLZ					;Clear Zero flag
		LDS		R16,RBCD3
		INC		R16
		STS		RBCD3,R16
		BRNE		No_Inc
		LDS		R16,RBCD2
		INC		R16
		STS		RBCD2,R16
No_Inc:		



Angle_Display:
		RCALL	BintoBCD			; Convert 24 bit binary value to 6 decimal digits

		LDS		R16,RBCD1
		RCALL   BYTE_Out			;Outputs 2 digit (BCD or HEX) value from R16
		LDS		R16,RBCD2
		RCALL   BYTE_Out		
		LDS		R16,RBCD3
		RCALL   BYTE_Out		



;		Now output units and tenths
		LDS		R16,Tenths
;		RCALL   BYTE_Out	
		
		
		RCALL	High_Nibble_OP		;Output High nibble of least significant byte 
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag. (LZBF)   so least significant "0" is output 
		STS		Flags,R17
		LDS		R16,Tenths			;
		RCALL	Low_Nibble_OP		;Output low nibble of least significant byte even if it is zero  
		POP		R17	
		
;		LDI		R16,0x0A	;	ASCII LF
;		RCALL	USART_TX
;		LDI		R16,0x0D	;	ASCII CR
;		RCALL	USART_TX
		RET
; ***************************************************************************************************************
; *				Format tacho data for output as string of ASCII charactes			*
; *														*
; *														*
; *														*
; ***************************************************************************************************************
Format_Tacho_Out:
		PUSH	R17	

		
		LDS		R17,Flags
		SBR		R17,0x40			;Set leading zero blanking flag. (LZBF) If set does not output zero  
		STS		Flags,R17

		LDS		R16,Tacho_H
	;	LDI		R16,0x00			; TEST ONLY
		STS		Rbin0,R16
		LDS		R16,Tacho_M
	;	LDI		R16,0x0B			; TEST ONLY
		STS		Rbin1,R16
		LDS		R16,Tacho_L
	;	LDI		R16,0xB8			; TEST ONLY
		STS		Rbin2,R16

		RCALL		BintoBCD			; Convert 24 bit binary value to 6 decimal digits

		LDS		R16,RBCD0
		RCALL		BYTE_Out	
		LDS		R16,RBCD1
		RCALL		 BYTE_Out			;Outputs 2 digit (BCD or HEX) value from R16
		LDS		R16,RBCD2
		RCALL		BYTE_Out	
		LDS		R16,RBCD3
		RCALL		High_Nibble_OP		;Output High nibble of least significant byte 
		LDS		R17,Flags
		CBR		R17,0x40			;Clear leading zero blanking flag. (LZBF)   so least significant "0" is output 
		STS		Flags,R17
		LDS		R16,RBCD3			;
		RCALL		Low_Nibble_OP		;Output low nibble of least significant byte even if it is zero  
		POP		R17
		RET


; ***************************************************************************************************************
; *		Set 2 * 24 bit scale to fast mode								*
; *		Use 16 bit counter/timer 1 for timing.								*
; *		On entry scale number in R16									*
; *														*
; ***************************************************************************************************************

Set_fast_mode:
		MOV		R17,R16			;Save scale number for later
		Valid_Type4Fast:
;									Set mux bits  Scale number in R16
;Set_Mux
		MOV		R16,R17				;Put scale number back in R16
		LDI		R17,0x40				;Mux add 0 and INH bit set
		DEC		R16	
		TST		R16
		BRMI	Set_Mux_Bits_end
		LDI		R17,0x50				;Mux add 1 and INH bit set					;
		DEC		R16	
		TST		R16
		BRMI	Set_Mux_Bits_end
		LDI		R17,0x48				;Mux add 2 and INH bit set	
		DEC		R16
		TST		R16
		BRMI	Set_Mux_Bits_end		;
		LDI		R17,0x58				;Mux add 3 and INH bit set
	Set_Mux_Bits_end:	

	; Now select the data pin for that scale
		ORI     R17,0x20			;Set Mux address line A which selects data pin
		OUT     PORTD,R17		 ;  Out to I/O location  (PORTD)
        NOP                      ;No operation Short delay
        CBI     PORTD,6           ;Clear 4051 multiplexor INH pin (ie remove inhibit) Data line now set high
		RCALL	Delay_300mS
		SBI     PORTD,6           ;Set bit 4051 multiplexor INH pin (ie  inhibit) No bits held high
		RCALL	Delay_300mS		
		ANDI    R17,0xDF			;Clear Mux address line A   which selects clock pin
		OUT     PORTD,R17		 ;  Out to I/O location  (PORTD)
		NOP                      ;No operation Short delay
        CBI     PORTD,6           ;Clear 4051 multiplexor INH pin (ie remove inhibit)  Clock line now held high
		RCALL	Delay_300mS
		SBI     PORTD,6           ;Set bit 4051 multiplexor INH pin (ie  inhibit) No bits held high
		RCALL	Delay_300mS

		RET


; ***************************************************************************************************************
; *		Delay 300 mS											*
; *		Used for timing output pulse for setting scale to fast mode					*
; *		Uses timer 1 (16 bit)										*
; *														*
; ***************************************************************************************************************


Delay_300mS:
	
		;						Timer increments every  12.8 uS   
		; So 300000/12.8 = 23437 = 0x5B8D      0x10000 - 0x5B8D = A473
		PUSH	R16
		LDI	R16,0xA4
		OUT     TCNT1H,R16		;Timer/counter 1   Set to 0x0000  (65536 * 12.8 uS  = 838.8608 mS)
		LDI	R16,0x73
		OUT     TCNT1L,R16
		LDI     R16,0x80         ;Bit 7  (TOV1) Timer/counter 1 overflow flag
		OUT     TIFR,R16		;Timer/counter interrupt flag register NOTE THIS CLEARS FLAG !

Del_300_1:
		IN	R16,TIFR
		SBRS    R16,7			
		RJMP	Del_300_1

		POP	R16
		RET

; ***************************************************************************************************************
; *	Delay_5_Sec:		Approximate delay of 5 seconds				 (17 * 300 mS)		*
; *		Used at power up to give scales time to be ready to be set into fast mode			*
; *														*
; *														*
; ***************************************************************************************************************

Delay_5_Sec:
		PUSH	R16					
		LDI		R16,17
Del_5_1:
		RCALL	Delay_300mS
		DEC		R16
		TST		R16
		BRNE	Del_5_1
		POP		R16
		RET

; ***************************************************************************************************************
; *	Test for fast node on 2 * 24 scales to avoid setting back to normal mode				*
; *	On entry scale number will be in R16									*
; *	On exit scale number still in R16   If scale 								*
; *														*
; ***************************************************************************************************************
Test_Fast_Mode:
		PUSH	R16
		STS		Scale_Number,R16

;Start a timeout timer  In slow mode scale send out about 3 frames per second

		RCALL   Set_Timer_Prescaler				;  Set_Timer1_prescaler to 256

TF01:

		LDI     R16,0x00			;Set up Timer 1 to use to indicate timeout
		;						Timer increments every  12.8 uS   
        OUT     TCNT1H,R16		;Timer/counter 1   Set to 0x0000  (65536 * 12.8 uS  = 838.8608 mS)
        OUT     TCNT1L,R16		;
		LDI     R16,0x80         ;Load immediate    Bit 7  (TOV1) Timer/counter 1 overflow flag
        OUT     TIFR,R16		;Timer/counter interrupt flag register NOTE THIS CLEARS FLAG !
								; Timmer now running
		LDS		R16,Scale_Number
		RCALL	Prep_for_Read		; Just to get scale mask
		LDS		R17,Scale_bit_mask

		
Test_4_Clock:
		IN		R16,TIFR
        SBRC    R16,7			
		RJMP	TF_Exit_S			;Timer has timed out so there are no clock pulses from scale

		IN		R16,PINB		
		ANDI	R16,0x0F		;Mask for clock bits
		AND		R16,R17				;Mask for current scale. (Clock)
		BREQ	Test_4_Clock	;no clocks found yet

		;Clock bit found so we must be in data frame
		; Now wait a bit longer than the length of a data frame  (It could be the first clock bt of a data frame)
		;Data frame is about 860 uS So wait about 1.5 mS  use timer 0    1500/12.8 = about 117    256 - 117 = 139 = 0x8B

		
		LDI		R16,0x8B
		OUT     TCNT0,R16		;Timer/counter 0  Set to 0x8B  117 * 12.8 uS  = 1.498 mS)
		LDI     R16,0x02         ;Load immediate    Bit 1  (TOV0) Timer/counter 1 overflow flag
        OUT     TIFR,R16		;Timer/counter interrupt flag register NOTE THIS CLEARS FLAG !
TF02:
		IN		R16,TIFR
        SBRS    R16,1			
		RJMP	TF02


		; Now look for clocks again, If in fast mode they should start again in about 23 mS If in normal mode it will be about 327 mS
		; So if a clock pulse is seen in less than 50 mS we must be in fast mode 
		; Clock bits are 7 uS wide so need to test for them more often than every 3 uS  50000/3 = 16667 times in the 50 mS period

		;Set timer 1 to timeout after about 50 mS.  50000/12.8 = 3906  65536 - 3906 = 61630 =  0xF0BE

		LDI     R16,0xF0			;Set up Timer 1 to use to indicate timeout
		;						Timer increments every  12.8 uS   
        OUT     TCNT1H,R16		;Timer/counter 1   Set to 0xF0BE
		LDI		R16,0xBE
        OUT     TCNT1L,R16		;
		LDI     R16,0x80         ;Load immediate    Bit 7  (TOV1) Timer/counter 1 overflow flag
        OUT     TIFR,R16		;Timer/counter interrupt flag register NOTE THIS CLEARS FLAG !
								; Timmer now running



TF03:
		IN		R16,TIFR
        SBRC    R16,7			
		RJMP	TF_Exit_S			;Timer has timed out so there are no clock pulses from scale in less than 50 mS

		IN		R16,PINB		
		ANDI	R16,0x0F		;Mask for clock bits
		AND		R16,R17				;Mask for current scale. (Clock)
		BREQ	TF03			;no clocks found yet
		CLN							;Clear Negative Flag Clock pulse found
	;	SBI		PORTD,2					;Set PORTD bit 2								ONLY FOR TESTING
		RJMP	TF_Exit_F
		; A clock pulse has been found in less than 50 mS so must be in fast mode

TF_Exit_S:
	;	CBI		PORTD,2			;Clear PORTD bit 2								ONLY FOR TESTING
		SEN							;Set Negative Flag  (Timeout if set)
TF_Exit_F:
		POP		R16
		RET



; ***************************************************************************************************************



; ***************************************************************************************************************
; *		Configure timer 0 for PWM operation								*
; *														*
; *														*
; *														*
; ***************************************************************************************************************

Config_PWM:
;Setup registers 
			LDI     R16,0x02         ; Clock source Bit 1 I/O clock /8 =20 *10^6 /8 =  2.5 MHz  (0.4 uS period) Bit 3 WGM2 clear, FOC0A & B clear
;										This means timer 1 will overflow every 256 * 0.4 uS = 102.4 us
			OUT		TCCR0B,R16	

			LDI		R16,0x03				;WGM 0 & 1 set, COM bits clear (Output not routed to I/O pins)
			OUT		TCCR0A,R16

			;Set compare to about 256 /5   = 51 = 0x33  

			LDI		R16,0x33
			OUT		OCR0A,R16

			;Enable TMR0 overflow and compare interrupts
			LDI		R16,0x03
			OUT		TIMSK,R16
			LDI		R26,0x00	;Init counter
			RET

		
; ***************************************************************************************************************
; *			Interupt handler for timer 0 compare							*
; *			When this interrupt occurs the clock is set low						*
; *														*
; *														*
; ***************************************************************************************************************
TIMER0_COMPA_Int:
			PUSH	R16
			IN		R11,SREG			;Save STATUS Reg.

			NOP			;Delay to allow scales to set data line. Probably not needed !
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP


			CBI		PORTD,2					;Clear PORTD bit 2  Set clock low
			LDS		R16,IG_Flags
			SBRS	R16,0					;Request read bit
			RJMP	IG_Input_Exit			;No read this time
			CPI		R22,0x15			;21
			BRSH	IG_Input_Exit				;Branch if same or higher

	;		SBI		PORTD,3				;Set PORTD bit 3			TEST
			IN      R16,PINB			;  Scale input		
			ANDI	R16,0xF0			;Mask for data bits
			AND     R16,R9				;Bit mask to select scale x input
			SEC							;Clear carry
			BRNE	IG_Input01
			CLC							 ;Set Carry

IG_Input01:
      		ROR     R5					;Rotate Right Through Carry Rotate carry bit into 24 MSB
      		ROR     R4
      		ROR     R3					;Rotate Right Through Carry	LSB
    ;  		CBI		PORTD,3					;Clear PORTD bit 3			TEST

IG_Input_Exit:
		OUT     SREG,R11			;Restore STATUS from location R11
		POP		R16
		RETI
; ***************************************************************************************************************
; *		Interupt handler  for timmer 0 overflow	  (Will occure every 102.4 uS)				*
; *				When this interrupt occurs the clock is set high				*
; *														*
; *														*
; ***************************************************************************************************************

TIM0_OVF_Int:
		PUSH	R16
		IN		R11,SREG			;Save STATUS Reg.

;Code to zero tacho reading if more than about 6 secondas have elapsed since last teading
		LDS	R16,Timer_L
		INC	R16
		STS	Timer_L,R16
		BRNE	TIM0_OF01
		LDS	R16,Timer_H
		INC	R16
		STS	Timer_H,R16
		BRNE	TIM0_OF01
		LDI	R16,0x00
		STS	Tacho_L,R16		;Set Tacho reading to zero
		STS	Tacho_M,R16
		STS	Tacho_H,R16
		LDI	R16,0x01	;Set bit 0 (Only this bit used.)
		STS	Tacho_Flags,R16	; Bit 0 set indicates new reading to ne sent to tablet.
TIM0_OF01:

;Code to check that the 3 bytes from the tach module are received within allocated time. (ie Are they all from the same group of 3 bytes.)

		LDS	R16,Byte_Count
		CPI	R16,0x00	;Check if Byte_Count is zero
		BRNE	TIM0_OF02
		LDI	R16,0x1D
		STS	Word_Timer,R16
		RJMP	TIM0_OF03
TIM0_OF02:
		LDS	R16,Word_Timer
		DEC	R16
		STS	Word_Timer,R16
		BRNE	TIM0_OF03
		LDI	R16,0x00
		STS	Byte_Count,R16		;Set byte count back to zero

TIM0_OF03:



		INC	R22				;Counts the number of iGaging clock pulses
		CPI	R22,0x45
		BRNE	Not_End
		LDI	R22,0x00			;Reset count
	;	CBI	PORTD,3					;Clear PORTD bit 3			TEST Clear at count = 45
Not_End:
		CPI	R22,0x15			;21 decimal
		BRSH	No_Set				;Branch if same or higher
		SBI	PORTD,2				;Set PORTD bit 2    Set clock high
			
No_Set:	
		BRNE	TIM0_OVF_Exit		;Wait_for_7mS		;( Equal to 21 from last CPI instruction Wait until 7 mS from start of current frame
		LDS	R16,IG_Flags
		CBR	R16,0x01			;Clear bit 0 Read request bit
	;	SBR	R16,0x80			;Set bit 7 Set when in inter frame gap (IFG)  Will use value of R22 instead
		STS	IG_Flags,R16
		

			

TIM0_OVF_Exit:
		OUT     SREG,R11			;Restore STATUS from location R11
		POP	R16
		RETI


; ***************************************************************************************************************
; *														*
; *														*
; *														*
; *														*
; ***************************************************************************************************************

; ***************************************************************************************************************
; *														*
; *	Look up table for bits 0 to 7	for angle gauge.							*
; *	Bits 0 to 7 are the address in the table.								*
; *	The entry in the table contains the number of 0.1 degrees AS A DECIMAL VALUE				*
; * one count represents 0.01953125 degrees									*
; ***************************************************************************************************************

.ORG	0x0780
Lookup_Table:
.DB	0x00,0x00			;0x00
.DB	0x00,0x01
.DB	0x01,0x01
.DB	0x01,0x01
.DB	0x02,0x02
.DB	0x02,0x02
.DB	0x02,0x03
.DB	0x03,0x03
.DB	0x03,0x03			;0x10   (16 Dec.)
.DB	0x04,0x04
.DB	0x04,0x04
.DB	0x04,0x04
.DB	0x05,0x05
.DB	0x05,0x05
.DB	0x05,0x06
.DB	0x06,0x06

.DB	0x06,0x06			;0x20   (32 Dec.)
.DB	0x07,0x07
.DB	0x07,0x07
.DB	0x07,0x08
.DB	0x08,0x08
.DB	0x08,0x08
.DB	0x09,0x09
.DB	0x09,0x09

.DB	0x09,0x10			;0x30   (48 Dec.)
.DB	0x10,0x10
.DB	0x10,0x10
.DB	0x11,0x11
.DB	0x11,0x11
.DB	0x11,0x12
.DB	0x12,0x12
.DB	0x12,0x12

.DB	0x12,0x13			;0x40   (64 Dec.)
.DB	0x13,0x13
.DB	0x13,0x13
.DB	0x14,0x14
.DB	0x14,0x14
.DB	0x14,0x15
.DB	0x15,0x15
.DB	0x15,0x15


.DB	0x16,0x16			;0x50   (80 Dec.)
.DB	0x16,0x16
.DB	0x16,0x17
.DB	0x17,0x17
.DB	0x17,0x17
.DB	0x18,0x18
.DB	0x18,0x18
.DB	0x18,0x19

.DB	0x19,0x19			;0x60   (96 Dec.)
.DB	0x19,0x19
.DB	0x20,0x20
.DB	0x20,0x20
.DB	0x20,0x21
.DB	0x21,0x21
.DB	0x21,0x21
.DB	0x21,0x22


.DB	0x22,0x22			;0x70   (112 Dec.)
.DB	0x22,0x22
.DB	0x23,0x23
.DB	0x23,0x23
.DB	0x23,0x24
.DB	0x24,0x24
.DB	0x24,0x24
.DB	0x25,0x25

.DB	0x25,0x25			;0x80   (128 Dec.)
.DB	0x25,0x26
.DB	0x26,0x26
.DB	0x26,0x26
.DB	0x27,0x27
.DB	0x27,0x27
.DB	0x27,0x28
.DB	0x28,0x28		;Corrected up to here

.DB	0x28,0x28			;0x90   (144 Dec.)
.DB	0x29,0x29
.DB	0x29,0x29
.DB	0x29,0x29
.DB	0x30,0x39
.DB	0x30,0x30
.DB	0x30,0x31
.DB	0x31,0x31

.DB	0x31,0x31			;0xA0   (160 Dec.)
.DB	0x32,0x32
.DB	0x32,0x32
.DB	0x32,0x33
.DB	0x33,0x33
.DB	0x33,0x33
.DB	0x34,0x34
.DB	0x34,0x34

.DB	0x34,0x35			;0xB0   (176 Dec.)
.DB	0x35,0x35
.DB	0x35,0x35
.DB	0x36,0x36
.DB	0x36,0x36
.DB	0x36,0x37
.DB	0x37,0x37
.DB	0x37,0x37	

.DB	0x37,0x38		;0xC0   (192 Dec.)
.DB	0x38,0x38
.DB	0x38,0x38
.DB	0x39,0x39
.DB	0x39,0x39
.DB	0x39,0x40
.DB	0x40,0x40
.DB	0x40,0x40


.DB	0x41,0x41			;0xD0   (208 Dec.)
.DB	0x41,0x41
.DB	0x41,0x42
.DB	0x42,0x42
.DB	0x42,0x42
.DB	0x43,0x43
.DB	0x43,0x43
.DB	0x43,0x44

.DB	0x44,0x44			;0xE0   (224 Dec.)
.DB	0x44,0x44
.DB	0x45,0x45
.DB	0x45,0x45
.DB	0x45,0x46
.DB	0x46,0x46
.DB	0x46,0x46
.DB	0x46,0x47

.DB	0x47,0x47			;0xF0   (240 Dec.)
.DB	0x47,0x47
.DB	0x48,0x48
.DB	0x48,0x48
.DB	0x48,0x49
.DB	0x49,0x49
.DB	0x49,0x49
.DB	0x50,0x50      ;Last two entrys should be zero but will need to increment the next digit.



; End of code
; NOTE Last program memory address on an ATtiny4313 is 0x07FF

;  ----------------------------------------- end -----------------------------
